/* moonshot-id.c generated by valac 0.10.4, the Vala compiler
 * generated from moonshot-id.vala, do not modify */

/*
 * Copyright (c) 2011-2016, JANET(UK)
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 *
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * 3. Neither the name of JANET(UK) nor the names of its contributors
 *    may be used to endorse or promote products derived from this software
 *    without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
 * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
*/

#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <gee.h>
#include <gnome-keyring-memory.h>


#define TYPE_TRUST_ANCHOR (trust_anchor_get_type ())
#define TRUST_ANCHOR(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_TRUST_ANCHOR, TrustAnchor))
#define TRUST_ANCHOR_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_TRUST_ANCHOR, TrustAnchorClass))
#define IS_TRUST_ANCHOR(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_TRUST_ANCHOR))
#define IS_TRUST_ANCHOR_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_TRUST_ANCHOR))
#define TRUST_ANCHOR_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_TRUST_ANCHOR, TrustAnchorClass))

typedef struct _TrustAnchor TrustAnchor;
typedef struct _TrustAnchorClass TrustAnchorClass;
typedef struct _TrustAnchorPrivate TrustAnchorPrivate;

#define TRUST_ANCHOR_TYPE_TRUST_ANCHOR_TYPE (trust_anchor_trust_anchor_type_get_type ())
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_regex_unref0(var) ((var == NULL) ? NULL : (var = (g_regex_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _g_date_time_unref0(var) ((var == NULL) ? NULL : (var = (g_date_time_unref (var), NULL)))

#define TYPE_MOONSHOT_LOGGER (moonshot_logger_get_type ())
#define MOONSHOT_LOGGER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_MOONSHOT_LOGGER, MoonshotLogger))
#define MOONSHOT_LOGGER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_MOONSHOT_LOGGER, MoonshotLoggerClass))
#define IS_MOONSHOT_LOGGER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_MOONSHOT_LOGGER))
#define IS_MOONSHOT_LOGGER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_MOONSHOT_LOGGER))
#define MOONSHOT_LOGGER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_MOONSHOT_LOGGER, MoonshotLoggerClass))

typedef struct _MoonshotLogger MoonshotLogger;
typedef struct _MoonshotLoggerClass MoonshotLoggerClass;

#define TYPE_RULE (rule_get_type ())
typedef struct _Rule Rule;

#define TYPE_ID_CARD (id_card_get_type ())
#define ID_CARD(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_ID_CARD, IdCard))
#define ID_CARD_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_ID_CARD, IdCardClass))
#define IS_ID_CARD(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_ID_CARD))
#define IS_ID_CARD_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_ID_CARD))
#define ID_CARD_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_ID_CARD, IdCardClass))

typedef struct _IdCard IdCard;
typedef struct _IdCardClass IdCardClass;
typedef struct _IdCardPrivate IdCardPrivate;

#define ID_CARD_TYPE_DIFF_FLAGS (id_card_diff_flags_get_type ())
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

struct _TrustAnchor {
	GObject parent_instance;
	TrustAnchorPrivate * priv;
};

struct _TrustAnchorClass {
	GObjectClass parent_class;
};

struct _TrustAnchorPrivate {
	char* _ca_cert;
	char* _subject;
	char* _subject_alt;
	char* _server_cert;
	char* _datetime_added;
};

typedef enum  {
	TRUST_ANCHOR_TRUST_ANCHOR_TYPE_EMPTY,
	TRUST_ANCHOR_TRUST_ANCHOR_TYPE_CA_CERT,
	TRUST_ANCHOR_TRUST_ANCHOR_TYPE_SERVER_CERT
} TrustAnchorTrustAnchorType;

struct _Rule {
	char* pattern;
	char* always_confirm;
};

struct _IdCard {
	GObject parent_instance;
	IdCardPrivate * priv;
};

struct _IdCardClass {
	GObjectClass parent_class;
};

struct _IdCardPrivate {
	char* _username;
	char* _issuer;
	char* _display_name;
	const char* _password;
	char* _mfa_code;
	Rule* _rules;
	gint _rules_length1;
	gint __rules_size_;
	GeeList* _services;
	gboolean _temporary;
	TrustAnchor* _trust_anchor;
	char* _nai;
	gboolean _store_password;
	gboolean _has_2fa;
	char* _uuid;
};

typedef enum  {
	ID_CARD_DIFF_FLAGS_DISPLAY_NAME,
	ID_CARD_DIFF_FLAGS_USERNAME,
	ID_CARD_DIFF_FLAGS_PASSWORD,
	ID_CARD_DIFF_FLAGS_ISSUER,
	ID_CARD_DIFF_FLAGS_RULES,
	ID_CARD_DIFF_FLAGS_SERVICES,
	ID_CARD_DIFF_FLAGS_TRUST_ANCHOR
} IdCardDiffFlags;


extern MoonshotLogger* id_card_logger;
static gpointer trust_anchor_parent_class = NULL;
MoonshotLogger* id_card_logger = NULL;
static gpointer id_card_parent_class = NULL;

gchar* get_cert_valid_before (guchar* inbuf, gint inlen, gchar* outbuf, gint outlen);
gboolean get_cert_is_expired_now (guchar* inbuf, gint inlen);
GType trust_anchor_get_type (void) G_GNUC_CONST;
#define TRUST_ANCHOR_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TYPE_TRUST_ANCHOR, TrustAnchorPrivate))
enum  {
	TRUST_ANCHOR_DUMMY_PROPERTY,
	TRUST_ANCHOR_CA_CERT,
	TRUST_ANCHOR_SUBJECT,
	TRUST_ANCHOR_SUBJECT_ALT,
	TRUST_ANCHOR_SERVER_CERT,
	TRUST_ANCHOR_DATETIME_ADDED
};
GType trust_anchor_trust_anchor_type_get_type (void) G_GNUC_CONST;
#define TRUST_ANCHOR_CERT_HEADER "-----BEGIN CERTIFICATE-----"
#define TRUST_ANCHOR_CERT_FOOTER "-----END CERTIFICATE-----"
static char* trust_anchor_fixup (const char* s);
TrustAnchor* trust_anchor_new (const char* ca_cert, const char* server_cert, const char* subject, const char* subject_alt);
TrustAnchor* trust_anchor_construct (GType object_type, const char* ca_cert, const char* server_cert, const char* subject, const char* subject_alt);
TrustAnchor* trust_anchor_new_empty (void);
TrustAnchor* trust_anchor_construct_empty (GType object_type);
gboolean trust_anchor_is_empty (TrustAnchor* self);
const char* trust_anchor_get_ca_cert (TrustAnchor* self);
const char* trust_anchor_get_server_cert (TrustAnchor* self);
TrustAnchorTrustAnchorType trust_anchor_get_anchor_type (TrustAnchor* self);
const char* trust_anchor_get_subject (TrustAnchor* self);
const char* trust_anchor_get_subject_alt (TrustAnchor* self);
void trust_anchor_set_datetime_added (TrustAnchor* self, const char* datetime);
char* trust_anchor_format_datetime_now (void);
void trust_anchor_update_server_fingerprint (TrustAnchor* self, const char* fingerprint);
gint trust_anchor_Compare (TrustAnchor* self, TrustAnchor* other);
char* trust_anchor_get_expiration_date (TrustAnchor* self);
GType moonshot_logger_get_type (void) G_GNUC_CONST;
void moonshot_logger_info (MoonshotLogger* self, const char* message, GError* e);
void moonshot_logger_trace (MoonshotLogger* self, const char* message, GError* e);
void moonshot_logger_error (MoonshotLogger* self, const char* message, GError* e);
gboolean trust_anchor_is_expired (TrustAnchor* self);
const char* trust_anchor_get_datetime_added (TrustAnchor* self);
static void trust_anchor_finalize (GObject* obj);
static void trust_anchor_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec);
GType rule_get_type (void) G_GNUC_CONST;
Rule* rule_dup (const Rule* self);
void rule_free (Rule* self);
void rule_copy (const Rule* self, Rule* dest);
void rule_destroy (Rule* self);
gint rule_Compare (Rule *self, Rule* other);
GType id_card_get_type (void) G_GNUC_CONST;
#define ID_CARD_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TYPE_ID_CARD, IdCardPrivate))
enum  {
	ID_CARD_DUMMY_PROPERTY,
	ID_CARD_DISPLAY_NAME,
	ID_CARD_USERNAME,
	ID_CARD_ISSUER,
	ID_CARD_PASSWORD,
	ID_CARD_MFA_CODE,
	ID_CARD_SERVICES,
	ID_CARD_TEMPORARY,
	ID_CARD_TRUST_ANCHOR,
	ID_CARD_NAI,
	ID_CARD_STORE_PASSWORD,
	ID_CARD_HAS_2FA,
	ID_CARD_UUID
};
GType id_card_diff_flags_get_type (void) G_GNUC_CONST;
MoonshotLogger* get_logger (const char* name);
static void _vala_Rule_array_free (Rule* array, gint array_length);
char* id_card_generate_uuid (void);
#define ID_CARD_NO_IDENTITY "No Identity"
static void id_card_update_nai (IdCard* self);
const char* id_card_get_username (IdCard* self);
const char* id_card_get_issuer (IdCard* self);
char* id_card_get_services_string (IdCard* self, const char* sep);
void id_card_update_services (IdCard* self, char** services, int services_length1);
void id_card_update_services_from_list (IdCard* self, GeeList* services);
void id_card_set_trust_anchor_from_store (IdCard* self, TrustAnchor* ta);
void id_card_clear_trust_anchor (IdCard* self);
gboolean id_card_is_no_identity (IdCard* self);
const char* id_card_get_display_name (IdCard* self);
gint id_card_Compare (IdCard* self, IdCard* other);
const char* id_card_get_password (IdCard* self);
gint CompareRules (Rule* a, int a_length1, Rule* b, int b_length1);
Rule* id_card_get_rules (IdCard* self, int* result_length1);
gint CompareStringArrayList (GeeList* a, GeeList* b);
TrustAnchor* id_card_get_trust_anchor (IdCard* self);
char* id_card_escape (const char* value);
IdCard* id_card_NewNoIdentity (void);
IdCard* id_card_new (void);
IdCard* id_card_construct (GType object_type);
void id_card_set_display_name (IdCard* self, const char* value);
void id_card_add_rule (IdCard* self, Rule* rule);
static void _vala_array_add2 (Rule** array, int* length, int* size, const Rule* value);
void id_card_set_username (IdCard* self, const char* value);
void id_card_set_issuer (IdCard* self, const char* value);
void id_card_set_password (IdCard* self, const char* value);
const char* id_card_get_mfa_code (IdCard* self);
void id_card_set_mfa_code (IdCard* self, const char* value);
void id_card_set_rules (IdCard* self, Rule* value, int value_length1);
static Rule* _vala_array_dup6 (Rule* self, int length);
static Rule* _vala_array_dup7 (Rule* self, int length);
GeeList* id_card_get_services (IdCard* self);
gboolean id_card_get_temporary (IdCard* self);
void id_card_set_temporary (IdCard* self, gboolean value);
const char* id_card_get_nai (IdCard* self);
static void id_card_set_nai (IdCard* self, const char* value);
gboolean id_card_get_store_password (IdCard* self);
void id_card_set_store_password (IdCard* self, gboolean value);
gboolean id_card_get_has_2fa (IdCard* self);
void id_card_set_has_2fa (IdCard* self, gboolean value);
const char* id_card_get_uuid (IdCard* self);
static void id_card_finalize (GObject* obj);
static void id_card_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec);
static void id_card_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec);
static void _vala_array_destroy (gpointer array, gint array_length, GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array, gint array_length, GDestroyNotify destroy_func);
static int _vala_strcmp0 (const char * str1, const char * str2);



GType trust_anchor_trust_anchor_type_get_type (void) {
	static volatile gsize trust_anchor_trust_anchor_type_type_id__volatile = 0;
	if (g_once_init_enter (&trust_anchor_trust_anchor_type_type_id__volatile)) {
		static const GEnumValue values[] = {{TRUST_ANCHOR_TRUST_ANCHOR_TYPE_EMPTY, "TRUST_ANCHOR_TRUST_ANCHOR_TYPE_EMPTY", "empty"}, {TRUST_ANCHOR_TRUST_ANCHOR_TYPE_CA_CERT, "TRUST_ANCHOR_TRUST_ANCHOR_TYPE_CA_CERT", "ca-cert"}, {TRUST_ANCHOR_TRUST_ANCHOR_TYPE_SERVER_CERT, "TRUST_ANCHOR_TRUST_ANCHOR_TYPE_SERVER_CERT", "server-cert"}, {0, NULL, NULL}};
		GType trust_anchor_trust_anchor_type_type_id;
		trust_anchor_trust_anchor_type_type_id = g_enum_register_static ("TrustAnchorTrustAnchorType", values);
		g_once_init_leave (&trust_anchor_trust_anchor_type_type_id__volatile, trust_anchor_trust_anchor_type_type_id);
	}
	return trust_anchor_trust_anchor_type_type_id__volatile;
}


#line 1051 "glib-2.0.vapi"
static char* string_strip (const char* self) {
#line 291 "moonshot-id.c"
	char* result = NULL;
	char* _result_;
#line 1051 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1052 "glib-2.0.vapi"
	_result_ = g_strdup (self);
#line 1053 "glib-2.0.vapi"
	g_strstrip (_result_);
#line 300 "moonshot-id.c"
	result = _result_;
#line 1054 "glib-2.0.vapi"
	return result;
#line 304 "moonshot-id.c"
}


#line 58 "moonshot-id.vala"
static char* trust_anchor_fixup (const char* s) {
#line 310 "moonshot-id.c"
	char* result = NULL;
	char* _tmp0_;
#line 58 "moonshot-id.vala"
	g_return_val_if_fail (s != NULL, NULL);
#line 315 "moonshot-id.c"
	_tmp0_ = NULL;
#line 59 "moonshot-id.vala"
	if (s == NULL) {
#line 319 "moonshot-id.c"
		char* _tmp1_;
#line 59 "moonshot-id.vala"
		_tmp0_ = (_tmp1_ = g_strdup (""), _g_free0 (_tmp0_), _tmp1_);
#line 323 "moonshot-id.c"
	} else {
		char* _tmp2_;
#line 59 "moonshot-id.vala"
		_tmp0_ = (_tmp2_ = string_strip (s), _g_free0 (_tmp0_), _tmp2_);
#line 328 "moonshot-id.c"
	}
	result = _tmp0_;
#line 59 "moonshot-id.vala"
	return result;
#line 333 "moonshot-id.c"
}


#line 1181 "glib-2.0.vapi"
static char* string_replace (const char* self, const char* old, const char* replacement) {
#line 339 "moonshot-id.c"
	char* result = NULL;
	GError * _inner_error_ = NULL;
#line 1181 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1181 "glib-2.0.vapi"
	g_return_val_if_fail (old != NULL, NULL);
#line 1181 "glib-2.0.vapi"
	g_return_val_if_fail (replacement != NULL, NULL);
#line 348 "moonshot-id.c"
	{
		char* _tmp0_;
		GRegex* _tmp1_;
		GRegex* regex;
		char* _tmp2_;
#line 1183 "glib-2.0.vapi"
		regex = (_tmp1_ = g_regex_new (_tmp0_ = g_regex_escape_string (old, -1), 0, 0, &_inner_error_), _g_free0 (_tmp0_), _tmp1_);
#line 356 "moonshot-id.c"
		if (_inner_error_ != NULL) {
			if (_inner_error_->domain == G_REGEX_ERROR) {
				goto __catch2_g_regex_error;
			}
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return NULL;
		}
#line 1184 "glib-2.0.vapi"
		_tmp2_ = g_regex_replace_literal (regex, self, (gssize) (-1), 0, replacement, 0, &_inner_error_);
#line 367 "moonshot-id.c"
		if (_inner_error_ != NULL) {
			_g_regex_unref0 (regex);
			if (_inner_error_->domain == G_REGEX_ERROR) {
				goto __catch2_g_regex_error;
			}
			_g_regex_unref0 (regex);
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return NULL;
		}
		result = _tmp2_;
		_g_regex_unref0 (regex);
#line 1184 "glib-2.0.vapi"
		return result;
#line 382 "moonshot-id.c"
	}
	goto __finally2;
	__catch2_g_regex_error:
	{
		GError * e;
		e = _inner_error_;
		_inner_error_ = NULL;
		{
#line 1186 "glib-2.0.vapi"
			g_assert_not_reached ();
#line 393 "moonshot-id.c"
			_g_error_free0 (e);
		}
	}
	__finally2:
	if (_inner_error_ != NULL) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return NULL;
	}
}


#line 62 "moonshot-id.vala"
TrustAnchor* trust_anchor_construct (GType object_type, const char* ca_cert, const char* server_cert, const char* subject, const char* subject_alt) {
#line 408 "moonshot-id.c"
	TrustAnchor * self = NULL;
	char* _tmp0_;
	char* _tmp1_;
	char* _tmp2_;
	char* _tmp3_;
	char* _tmp4_;
	char* cruft;
	char* _tmp5_;
#line 62 "moonshot-id.vala"
	g_return_val_if_fail (ca_cert != NULL, NULL);
#line 62 "moonshot-id.vala"
	g_return_val_if_fail (server_cert != NULL, NULL);
#line 62 "moonshot-id.vala"
	g_return_val_if_fail (subject != NULL, NULL);
#line 62 "moonshot-id.vala"
	g_return_val_if_fail (subject_alt != NULL, NULL);
#line 62 "moonshot-id.vala"
	self = (TrustAnchor*) g_object_new (object_type, NULL);
#line 63 "moonshot-id.vala"
	self->priv->_ca_cert = (_tmp0_ = trust_anchor_fixup (ca_cert), _g_free0 (self->priv->_ca_cert), _tmp0_);
#line 64 "moonshot-id.vala"
	self->priv->_server_cert = (_tmp1_ = trust_anchor_fixup (server_cert), _g_free0 (self->priv->_server_cert), _tmp1_);
#line 65 "moonshot-id.vala"
	self->priv->_subject = (_tmp2_ = trust_anchor_fixup (subject), _g_free0 (self->priv->_subject), _tmp2_);
#line 66 "moonshot-id.vala"
	self->priv->_subject_alt = (_tmp3_ = trust_anchor_fixup (subject_alt), _g_free0 (self->priv->_subject_alt), _tmp3_);
#line 69 "moonshot-id.vala"
	self->priv->_datetime_added = (_tmp4_ = g_strdup (""), _g_free0 (self->priv->_datetime_added), _tmp4_);
#line 73 "moonshot-id.vala"
	cruft = g_strdup ("<!-- Remove the begin and end lines from the PEM output of\n" \
"openssl to produce this format.  Alternatively, base64 encode a DER fo" \
"rmat certificate -->");
#line 75 "moonshot-id.vala"
	self->priv->_ca_cert = (_tmp5_ = string_replace (self->priv->_ca_cert, cruft, ""), _g_free0 (self->priv->_ca_cert), _tmp5_);
#line 441 "moonshot-id.c"
	_g_free0 (cruft);
	return self;
}


#line 62 "moonshot-id.vala"
TrustAnchor* trust_anchor_new (const char* ca_cert, const char* server_cert, const char* subject, const char* subject_alt) {
#line 62 "moonshot-id.vala"
	return trust_anchor_construct (TYPE_TRUST_ANCHOR, ca_cert, server_cert, subject, subject_alt);
#line 451 "moonshot-id.c"
}


#line 78 "moonshot-id.vala"
TrustAnchor* trust_anchor_construct_empty (GType object_type) {
#line 457 "moonshot-id.c"
	TrustAnchor * self = NULL;
#line 78 "moonshot-id.vala"
	self = (TrustAnchor*) g_object_new (object_type, NULL);
#line 461 "moonshot-id.c"
	return self;
}


#line 78 "moonshot-id.vala"
TrustAnchor* trust_anchor_new_empty (void) {
#line 78 "moonshot-id.vala"
	return trust_anchor_construct_empty (TYPE_TRUST_ANCHOR);
#line 470 "moonshot-id.c"
}


#line 113 "moonshot-id.vala"
gboolean trust_anchor_is_empty (TrustAnchor* self) {
#line 476 "moonshot-id.c"
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
#line 113 "moonshot-id.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 114 "moonshot-id.vala"
	if (_vala_strcmp0 (trust_anchor_get_ca_cert (self), "") == 0) {
#line 114 "moonshot-id.vala"
		_tmp0_ = _vala_strcmp0 (trust_anchor_get_server_cert (self), "") == 0;
#line 485 "moonshot-id.c"
	} else {
#line 114 "moonshot-id.vala"
		_tmp0_ = FALSE;
#line 489 "moonshot-id.c"
	}
	result = _tmp0_;
#line 114 "moonshot-id.vala"
	return result;
#line 494 "moonshot-id.c"
}


#line 117 "moonshot-id.vala"
TrustAnchorTrustAnchorType trust_anchor_get_anchor_type (TrustAnchor* self) {
#line 500 "moonshot-id.c"
	TrustAnchorTrustAnchorType result = 0;
	TrustAnchorTrustAnchorType _tmp0_ = 0;
	gboolean _tmp1_ = FALSE;
#line 117 "moonshot-id.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 118 "moonshot-id.vala"
	if (_vala_strcmp0 (trust_anchor_get_ca_cert (self), "") != 0) {
#line 508 "moonshot-id.c"
		gboolean _tmp2_ = FALSE;
#line 118 "moonshot-id.vala"
		if (_vala_strcmp0 (trust_anchor_get_subject (self), "") != 0) {
#line 118 "moonshot-id.vala"
			_tmp2_ = TRUE;
#line 514 "moonshot-id.c"
		} else {
#line 118 "moonshot-id.vala"
			_tmp2_ = _vala_strcmp0 (trust_anchor_get_subject_alt (self), "") != 0;
#line 518 "moonshot-id.c"
		}
#line 118 "moonshot-id.vala"
		_tmp1_ = _tmp2_;
#line 522 "moonshot-id.c"
	} else {
#line 118 "moonshot-id.vala"
		_tmp1_ = FALSE;
#line 526 "moonshot-id.c"
	}
#line 118 "moonshot-id.vala"
	if (_tmp1_) {
#line 118 "moonshot-id.vala"
		_tmp0_ = TRUST_ANCHOR_TRUST_ANCHOR_TYPE_CA_CERT;
#line 532 "moonshot-id.c"
	} else {
		TrustAnchorTrustAnchorType _tmp3_ = 0;
#line 119 "moonshot-id.vala"
		if (_vala_strcmp0 (trust_anchor_get_server_cert (self), "") != 0) {
#line 119 "moonshot-id.vala"
			_tmp3_ = TRUST_ANCHOR_TRUST_ANCHOR_TYPE_SERVER_CERT;
#line 539 "moonshot-id.c"
		} else {
#line 119 "moonshot-id.vala"
			_tmp3_ = TRUST_ANCHOR_TRUST_ANCHOR_TYPE_EMPTY;
#line 543 "moonshot-id.c"
		}
#line 119 "moonshot-id.vala"
		_tmp0_ = _tmp3_;
#line 547 "moonshot-id.c"
	}
	result = _tmp0_;
#line 118 "moonshot-id.vala"
	return result;
#line 552 "moonshot-id.c"
}


#line 122 "moonshot-id.vala"
void trust_anchor_set_datetime_added (TrustAnchor* self, const char* datetime) {
#line 558 "moonshot-id.c"
	char* _tmp0_;
#line 122 "moonshot-id.vala"
	g_return_if_fail (self != NULL);
#line 122 "moonshot-id.vala"
	g_return_if_fail (datetime != NULL);
#line 123 "moonshot-id.vala"
	self->priv->_datetime_added = (_tmp0_ = trust_anchor_fixup (datetime), _g_free0 (self->priv->_datetime_added), _tmp0_);
#line 566 "moonshot-id.c"
}


#line 126 "moonshot-id.vala"
char* trust_anchor_format_datetime_now (void) {
#line 572 "moonshot-id.c"
	char* result = NULL;
	GDateTime* now;
	char* dt;
#line 127 "moonshot-id.vala"
	now = g_date_time_new_now_utc ();
#line 128 "moonshot-id.vala"
	dt = g_date_time_format (now, "%b %d %T %Y %Z");
#line 580 "moonshot-id.c"
	result = dt;
	_g_date_time_unref0 (now);
#line 129 "moonshot-id.vala"
	return result;
#line 585 "moonshot-id.c"
}


#line 132 "moonshot-id.vala"
void trust_anchor_update_server_fingerprint (TrustAnchor* self, const char* fingerprint) {
#line 591 "moonshot-id.c"
	char* _tmp0_;
	char* ta_datetime_added;
#line 132 "moonshot-id.vala"
	g_return_if_fail (self != NULL);
#line 132 "moonshot-id.vala"
	g_return_if_fail (fingerprint != NULL);
#line 133 "moonshot-id.vala"
	self->priv->_server_cert = (_tmp0_ = g_strdup (fingerprint), _g_free0 (self->priv->_server_cert), _tmp0_);
#line 134 "moonshot-id.vala"
	ta_datetime_added = trust_anchor_format_datetime_now ();
#line 135 "moonshot-id.vala"
	trust_anchor_set_datetime_added (self, ta_datetime_added);
#line 604 "moonshot-id.c"
	_g_free0 (ta_datetime_added);
}


#line 138 "moonshot-id.vala"
gint trust_anchor_Compare (TrustAnchor* self, TrustAnchor* other) {
#line 611 "moonshot-id.c"
	gint result = 0;
#line 138 "moonshot-id.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 138 "moonshot-id.vala"
	g_return_val_if_fail (other != NULL, 0);
#line 140 "moonshot-id.vala"
	if (_vala_strcmp0 (trust_anchor_get_ca_cert (self), trust_anchor_get_ca_cert (other)) != 0) {
#line 619 "moonshot-id.c"
		result = 1;
#line 142 "moonshot-id.vala"
		return result;
#line 623 "moonshot-id.c"
	}
#line 144 "moonshot-id.vala"
	if (_vala_strcmp0 (trust_anchor_get_subject (self), trust_anchor_get_subject (other)) != 0) {
#line 627 "moonshot-id.c"
		result = 1;
#line 146 "moonshot-id.vala"
		return result;
#line 631 "moonshot-id.c"
	}
#line 148 "moonshot-id.vala"
	if (_vala_strcmp0 (trust_anchor_get_subject_alt (self), trust_anchor_get_subject_alt (other)) != 0) {
#line 635 "moonshot-id.c"
		result = 1;
#line 150 "moonshot-id.vala"
		return result;
#line 639 "moonshot-id.c"
	}
#line 152 "moonshot-id.vala"
	if (_vala_strcmp0 (trust_anchor_get_server_cert (self), trust_anchor_get_server_cert (other)) != 0) {
#line 643 "moonshot-id.c"
		result = 1;
#line 154 "moonshot-id.vala"
		return result;
#line 647 "moonshot-id.c"
	}
	result = 0;
#line 159 "moonshot-id.vala"
	return result;
#line 652 "moonshot-id.c"
}


#line 1035 "glib-2.0.vapi"
static char* string_chomp (const char* self) {
#line 658 "moonshot-id.c"
	char* result = NULL;
	char* _result_;
#line 1035 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1036 "glib-2.0.vapi"
	_result_ = g_strdup (self);
#line 1037 "glib-2.0.vapi"
	g_strchomp (_result_);
#line 667 "moonshot-id.c"
	result = _result_;
#line 1038 "glib-2.0.vapi"
	return result;
#line 671 "moonshot-id.c"
}


static glong string_get_length (const char* self) {
	glong result;
	g_return_val_if_fail (self != NULL, 0L);
	result = g_utf8_strlen (self, (gssize) (-1));
#line 1194 "glib-2.0.vapi"
	return result;
#line 681 "moonshot-id.c"
}


#line 1212 "glib-2.0.vapi"
static const char* string_to_string (const char* self) {
#line 687 "moonshot-id.c"
	const char* result = NULL;
#line 1212 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 691 "moonshot-id.c"
	result = self;
#line 1213 "glib-2.0.vapi"
	return result;
#line 695 "moonshot-id.c"
}


#line 162 "moonshot-id.vala"
char* trust_anchor_get_expiration_date (TrustAnchor* self) {
#line 701 "moonshot-id.c"
	char* result = NULL;
	char* cert;
	char* _tmp0_;
	gint binary_length1;
	gint _binary_size_;
	guchar* _tmp2_;
	size_t _tmp1_;
	guchar* binary;
	char* _tmp3_;
	gchar buf[64] = {0};
	char* err;
	char* date;
	char* _tmp5_;
#line 162 "moonshot-id.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 164 "moonshot-id.vala"
	if (_vala_strcmp0 (trust_anchor_get_ca_cert (self), "") == 0) {
#line 165 "moonshot-id.vala"
		moonshot_logger_info (id_card_logger, "Trust anchor does not have a ca_certificate", NULL);
#line 721 "moonshot-id.c"
		result = NULL;
#line 166 "moonshot-id.vala"
		return result;
#line 725 "moonshot-id.c"
	}
#line 169 "moonshot-id.vala"
	cert = g_strdup (trust_anchor_get_ca_cert (self));
#line 170 "moonshot-id.vala"
	_tmp0_ = string_chomp (cert);
#line 731 "moonshot-id.c"
	_g_free0 (_tmp0_);
	binary = (_tmp2_ = g_base64_decode (cert, &_tmp1_), binary_length1 = _tmp1_, _binary_size_ = binary_length1, _tmp2_);
#line 173 "moonshot-id.vala"
	moonshot_logger_trace (id_card_logger, _tmp3_ = g_strdup_printf ("get_expiration_date: encoded length=%ld; decoded length=%d", string_get_length (cert), binary_length1), NULL);
#line 736 "moonshot-id.c"
	_g_free0 (_tmp3_);
#line 176 "moonshot-id.vala"
	err = (char*) get_cert_valid_before (binary, binary_length1, buf, 64);
#line 177 "moonshot-id.vala"
	if (_vala_strcmp0 (err, "") != 0) {
#line 742 "moonshot-id.c"
		char* _tmp4_;
#line 178 "moonshot-id.vala"
		moonshot_logger_error (id_card_logger, _tmp4_ = g_strconcat ("get_expiration_date: get_cert_valid_before returned '", string_to_string (err), "'", NULL), NULL);
#line 746 "moonshot-id.c"
		_g_free0 (_tmp4_);
		result = NULL;
		_g_free0 (err);
		binary = (g_free (binary), NULL);
		_g_free0 (cert);
#line 179 "moonshot-id.vala"
		return result;
#line 754 "moonshot-id.c"
	}
#line 182 "moonshot-id.vala"
	date = g_strdup ((const char*) buf);
#line 183 "moonshot-id.vala"
	moonshot_logger_trace (id_card_logger, _tmp5_ = g_strconcat ("get_expiration_date: get_cert_valid_before returned '", string_to_string (date), "'", NULL), NULL);
#line 760 "moonshot-id.c"
	_g_free0 (_tmp5_);
	result = date;
	_g_free0 (err);
	binary = (g_free (binary), NULL);
	_g_free0 (cert);
#line 185 "moonshot-id.vala"
	return result;
#line 768 "moonshot-id.c"
}


#line 188 "moonshot-id.vala"
gboolean trust_anchor_is_expired (TrustAnchor* self) {
#line 774 "moonshot-id.c"
	gboolean result = FALSE;
	char* cert;
	char* _tmp0_;
	gint binary_length1;
	gint _binary_size_;
	guchar* _tmp2_;
	size_t _tmp1_;
	guchar* binary;
	char* _tmp3_;
#line 188 "moonshot-id.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 190 "moonshot-id.vala"
	if (_vala_strcmp0 (trust_anchor_get_ca_cert (self), "") == 0) {
#line 788 "moonshot-id.c"
		result = FALSE;
#line 191 "moonshot-id.vala"
		return result;
#line 792 "moonshot-id.c"
	}
#line 193 "moonshot-id.vala"
	cert = g_strdup (trust_anchor_get_ca_cert (self));
#line 194 "moonshot-id.vala"
	_tmp0_ = string_chomp (cert);
#line 798 "moonshot-id.c"
	_g_free0 (_tmp0_);
	binary = (_tmp2_ = g_base64_decode (cert, &_tmp1_), binary_length1 = _tmp1_, _binary_size_ = binary_length1, _tmp2_);
#line 197 "moonshot-id.vala"
	moonshot_logger_trace (id_card_logger, _tmp3_ = g_strdup_printf ("is_expired: encoded length=%ld; decoded length=%d", string_get_length (cert), binary_length1), NULL);
#line 803 "moonshot-id.c"
	_g_free0 (_tmp3_);
	result = get_cert_is_expired_now (binary, binary_length1);
	binary = (g_free (binary), NULL);
	_g_free0 (cert);
#line 198 "moonshot-id.vala"
	return result;
#line 810 "moonshot-id.c"
}


const char* trust_anchor_get_ca_cert (TrustAnchor* self) {
	const char* result;
	g_return_val_if_fail (self != NULL, NULL);
	result = self->priv->_ca_cert;
#line 84 "moonshot-id.vala"
	return result;
#line 820 "moonshot-id.c"
}


const char* trust_anchor_get_subject (TrustAnchor* self) {
	const char* result;
	g_return_val_if_fail (self != NULL, NULL);
	result = self->priv->_subject;
#line 90 "moonshot-id.vala"
	return result;
#line 830 "moonshot-id.c"
}


const char* trust_anchor_get_subject_alt (TrustAnchor* self) {
	const char* result;
	g_return_val_if_fail (self != NULL, NULL);
	result = self->priv->_subject_alt;
#line 96 "moonshot-id.vala"
	return result;
#line 840 "moonshot-id.c"
}


const char* trust_anchor_get_server_cert (TrustAnchor* self) {
	const char* result;
	g_return_val_if_fail (self != NULL, NULL);
	result = self->priv->_server_cert;
#line 103 "moonshot-id.vala"
	return result;
#line 850 "moonshot-id.c"
}


const char* trust_anchor_get_datetime_added (TrustAnchor* self) {
	const char* result;
	g_return_val_if_fail (self != NULL, NULL);
	result = self->priv->_datetime_added;
#line 109 "moonshot-id.vala"
	return result;
#line 860 "moonshot-id.c"
}


static void trust_anchor_class_init (TrustAnchorClass * klass) {
	trust_anchor_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (TrustAnchorPrivate));
	G_OBJECT_CLASS (klass)->get_property = trust_anchor_get_property;
	G_OBJECT_CLASS (klass)->finalize = trust_anchor_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), TRUST_ANCHOR_CA_CERT, g_param_spec_string ("ca-cert", "ca-cert", "ca-cert", NULL, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), TRUST_ANCHOR_SUBJECT, g_param_spec_string ("subject", "subject", "subject", NULL, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), TRUST_ANCHOR_SUBJECT_ALT, g_param_spec_string ("subject-alt", "subject-alt", "subject-alt", NULL, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), TRUST_ANCHOR_SERVER_CERT, g_param_spec_string ("server-cert", "server-cert", "server-cert", NULL, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), TRUST_ANCHOR_DATETIME_ADDED, g_param_spec_string ("datetime-added", "datetime-added", "datetime-added", NULL, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
}


static void trust_anchor_instance_init (TrustAnchor * self) {
	self->priv = TRUST_ANCHOR_GET_PRIVATE (self);
	self->priv->_ca_cert = g_strdup ("");
	self->priv->_subject = g_strdup ("");
	self->priv->_subject_alt = g_strdup ("");
	self->priv->_server_cert = g_strdup ("");
	self->priv->_datetime_added = g_strdup ("");
}


static void trust_anchor_finalize (GObject* obj) {
	TrustAnchor * self;
	self = TRUST_ANCHOR (obj);
	_g_free0 (self->priv->_ca_cert);
	_g_free0 (self->priv->_subject);
	_g_free0 (self->priv->_subject_alt);
	_g_free0 (self->priv->_server_cert);
	_g_free0 (self->priv->_datetime_added);
	G_OBJECT_CLASS (trust_anchor_parent_class)->finalize (obj);
}


GType trust_anchor_get_type (void) {
	static volatile gsize trust_anchor_type_id__volatile = 0;
	if (g_once_init_enter (&trust_anchor_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (TrustAnchorClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) trust_anchor_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (TrustAnchor), 0, (GInstanceInitFunc) trust_anchor_instance_init, NULL };
		GType trust_anchor_type_id;
		trust_anchor_type_id = g_type_register_static (G_TYPE_OBJECT, "TrustAnchor", &g_define_type_info, 0);
		g_once_init_leave (&trust_anchor_type_id__volatile, trust_anchor_type_id);
	}
	return trust_anchor_type_id__volatile;
}


static void trust_anchor_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec) {
	TrustAnchor * self;
	self = TRUST_ANCHOR (object);
	switch (property_id) {
		case TRUST_ANCHOR_CA_CERT:
		g_value_set_string (value, trust_anchor_get_ca_cert (self));
		break;
		case TRUST_ANCHOR_SUBJECT:
		g_value_set_string (value, trust_anchor_get_subject (self));
		break;
		case TRUST_ANCHOR_SUBJECT_ALT:
		g_value_set_string (value, trust_anchor_get_subject_alt (self));
		break;
		case TRUST_ANCHOR_SERVER_CERT:
		g_value_set_string (value, trust_anchor_get_server_cert (self));
		break;
		case TRUST_ANCHOR_DATETIME_ADDED:
		g_value_set_string (value, trust_anchor_get_datetime_added (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}


#line 207 "moonshot-id.vala"
gint rule_Compare (Rule *self, Rule* other) {
#line 939 "moonshot-id.c"
	gint result = 0;
#line 208 "moonshot-id.vala"
	if (_vala_strcmp0 ((*self).pattern, (*other).pattern) != 0) {
#line 943 "moonshot-id.c"
		result = 1;
#line 209 "moonshot-id.vala"
		return result;
#line 947 "moonshot-id.c"
	}
#line 210 "moonshot-id.vala"
	if (_vala_strcmp0 ((*self).always_confirm, (*other).always_confirm) != 0) {
#line 951 "moonshot-id.c"
		result = 1;
#line 211 "moonshot-id.vala"
		return result;
#line 955 "moonshot-id.c"
	}
	result = 0;
#line 212 "moonshot-id.vala"
	return result;
#line 960 "moonshot-id.c"
}


void rule_copy (const Rule* self, Rule* dest) {
	dest->pattern = g_strdup (self->pattern);
	dest->always_confirm = g_strdup (self->always_confirm);
}


void rule_destroy (Rule* self) {
	_g_free0 (self->pattern);
	_g_free0 (self->always_confirm);
}


Rule* rule_dup (const Rule* self) {
	Rule* dup;
	dup = g_new0 (Rule, 1);
	rule_copy (self, dup);
	return dup;
}


void rule_free (Rule* self) {
	rule_destroy (self);
	g_free (self);
}


GType rule_get_type (void) {
	static volatile gsize rule_type_id__volatile = 0;
	if (g_once_init_enter (&rule_type_id__volatile)) {
		GType rule_type_id;
		rule_type_id = g_boxed_type_register_static ("Rule", (GBoxedCopyFunc) rule_dup, (GBoxedFreeFunc) rule_free);
		g_once_init_leave (&rule_type_id__volatile, rule_type_id);
	}
	return rule_type_id__volatile;
}


GType id_card_diff_flags_get_type (void) {
	static volatile gsize id_card_diff_flags_type_id__volatile = 0;
	if (g_once_init_enter (&id_card_diff_flags_type_id__volatile)) {
		static const GEnumValue values[] = {{ID_CARD_DIFF_FLAGS_DISPLAY_NAME, "ID_CARD_DIFF_FLAGS_DISPLAY_NAME", "display-name"}, {ID_CARD_DIFF_FLAGS_USERNAME, "ID_CARD_DIFF_FLAGS_USERNAME", "username"}, {ID_CARD_DIFF_FLAGS_PASSWORD, "ID_CARD_DIFF_FLAGS_PASSWORD", "password"}, {ID_CARD_DIFF_FLAGS_ISSUER, "ID_CARD_DIFF_FLAGS_ISSUER", "issuer"}, {ID_CARD_DIFF_FLAGS_RULES, "ID_CARD_DIFF_FLAGS_RULES", "rules"}, {ID_CARD_DIFF_FLAGS_SERVICES, "ID_CARD_DIFF_FLAGS_SERVICES", "services"}, {ID_CARD_DIFF_FLAGS_TRUST_ANCHOR, "ID_CARD_DIFF_FLAGS_TRUST_ANCHOR", "trust-anchor"}, {0, NULL, NULL}};
		GType id_card_diff_flags_type_id;
		id_card_diff_flags_type_id = g_enum_register_static ("IdCardDiffFlags", values);
		g_once_init_leave (&id_card_diff_flags_type_id__volatile, id_card_diff_flags_type_id);
	}
	return id_card_diff_flags_type_id__volatile;
}


static void _vala_Rule_array_free (Rule* array, gint array_length) {
	if (array != NULL) {
		int i;
		for (i = 0; i < array_length; i = i + 1) {
			rule_destroy (&array[i]);
		}
	}
	g_free (array);
}


#line 247 "moonshot-id.vala"
static void id_card_update_nai (IdCard* self) {
#line 1026 "moonshot-id.c"
	char* _tmp0_;
	char* _tmp1_;
#line 247 "moonshot-id.vala"
	g_return_if_fail (self != NULL);
#line 248 "moonshot-id.vala"
	self->priv->_nai = (_tmp1_ = g_strconcat (_tmp0_ = g_strconcat (id_card_get_username (self), "@", NULL), id_card_get_issuer (self), NULL), _g_free0 (self->priv->_nai), _tmp1_);
#line 1033 "moonshot-id.c"
	_g_free0 (_tmp0_);
}


#line 284 "moonshot-id.vala"
char* id_card_get_services_string (IdCard* self, const char* sep) {
#line 1040 "moonshot-id.c"
	char* result = NULL;
	gint svcs_length1;
	gint _svcs_size_;
	char** _tmp1_;
	gint _tmp0_;
	char** svcs;
#line 284 "moonshot-id.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 284 "moonshot-id.vala"
	g_return_val_if_fail (sep != NULL, NULL);
#line 285 "moonshot-id.vala"
	if (gee_collection_get_is_empty ((GeeCollection*) self->priv->_services)) {
#line 1053 "moonshot-id.c"
		result = g_strdup ("");
#line 286 "moonshot-id.vala"
		return result;
#line 1057 "moonshot-id.c"
	}
	svcs = (_tmp1_ = g_new0 (char*, (_tmp0_ = gee_collection_get_size ((GeeCollection*) self->priv->_services)) + 1), svcs_length1 = _tmp0_, _svcs_size_ = svcs_length1, _tmp1_);
	{
		gint i;
#line 297 "moonshot-id.vala"
		i = 0;
#line 1064 "moonshot-id.c"
		{
			gboolean _tmp2_;
#line 297 "moonshot-id.vala"
			_tmp2_ = TRUE;
#line 297 "moonshot-id.vala"
			while (TRUE) {
#line 1071 "moonshot-id.c"
				char* _tmp3_;
#line 297 "moonshot-id.vala"
				if (!_tmp2_) {
#line 297 "moonshot-id.vala"
					i++;
#line 1077 "moonshot-id.c"
				}
#line 297 "moonshot-id.vala"
				_tmp2_ = FALSE;
#line 297 "moonshot-id.vala"
				if (!(i < gee_collection_get_size ((GeeCollection*) self->priv->_services))) {
#line 297 "moonshot-id.vala"
					break;
#line 1085 "moonshot-id.c"
				}
#line 298 "moonshot-id.vala"
				svcs[i] = (_tmp3_ = (char*) gee_list_get (self->priv->_services, i), _g_free0 (svcs[i]), _tmp3_);
#line 1089 "moonshot-id.c"
			}
		}
	}
	result = g_strjoinv (sep, svcs);
	svcs = (_vala_array_free (svcs, svcs_length1, (GDestroyNotify) g_free), NULL);
#line 301 "moonshot-id.vala"
	return result;
#line 1097 "moonshot-id.c"
}


#line 304 "moonshot-id.vala"
void id_card_update_services (IdCard* self, char** services, int services_length1) {
#line 304 "moonshot-id.vala"
	g_return_if_fail (self != NULL);
#line 305 "moonshot-id.vala"
	gee_collection_clear ((GeeCollection*) self->priv->_services);
#line 310 "moonshot-id.vala"
	if (services != NULL) {
#line 1109 "moonshot-id.c"
		{
			char** s_collection;
			int s_collection_length1;
			int s_it;
#line 311 "moonshot-id.vala"
			s_collection = services;
#line 1116 "moonshot-id.c"
			s_collection_length1 = services_length1;
			for (s_it = 0; s_it < services_length1; s_it = s_it + 1) {
				char* s;
				s = g_strdup (s_collection[s_it]);
				{
#line 312 "moonshot-id.vala"
					gee_collection_add ((GeeCollection*) self->priv->_services, s);
#line 1124 "moonshot-id.c"
					_g_free0 (s);
				}
			}
		}
	}
}


#line 317 "moonshot-id.vala"
void id_card_update_services_from_list (IdCard* self, GeeList* services) {
#line 317 "moonshot-id.vala"
	g_return_if_fail (self != NULL);
#line 317 "moonshot-id.vala"
	g_return_if_fail (services != NULL);
#line 318 "moonshot-id.vala"
	if (services == self->priv->_services) {
#line 320 "moonshot-id.vala"
		return;
#line 1143 "moonshot-id.c"
	}
#line 323 "moonshot-id.vala"
	gee_collection_clear ((GeeCollection*) self->priv->_services);
#line 325 "moonshot-id.vala"
	if (services != NULL) {
#line 326 "moonshot-id.vala"
		gee_collection_add_all ((GeeCollection*) self->priv->_services, (GeeCollection*) services);
#line 1151 "moonshot-id.c"
	}
}


static gpointer _g_object_ref0 (gpointer self) {
	return self ? g_object_ref (self) : NULL;
}


#line 341 "moonshot-id.vala"
void id_card_set_trust_anchor_from_store (IdCard* self, TrustAnchor* ta) {
#line 1163 "moonshot-id.c"
	TrustAnchor* _tmp0_;
#line 341 "moonshot-id.vala"
	g_return_if_fail (self != NULL);
#line 341 "moonshot-id.vala"
	g_return_if_fail (ta != NULL);
#line 342 "moonshot-id.vala"
	self->priv->_trust_anchor = (_tmp0_ = _g_object_ref0 (ta), _g_object_unref0 (self->priv->_trust_anchor), _tmp0_);
#line 1171 "moonshot-id.c"
}


#line 345 "moonshot-id.vala"
void id_card_clear_trust_anchor (IdCard* self) {
#line 1177 "moonshot-id.c"
	TrustAnchor* _tmp0_;
#line 345 "moonshot-id.vala"
	g_return_if_fail (self != NULL);
#line 346 "moonshot-id.vala"
	self->priv->_trust_anchor = (_tmp0_ = trust_anchor_new_empty (), _g_object_unref0 (self->priv->_trust_anchor), _tmp0_);
#line 1183 "moonshot-id.c"
}


#line 361 "moonshot-id.vala"
char* id_card_generate_uuid (void) {
#line 1189 "moonshot-id.c"
	char* result = NULL;
	guint32 rand1;
	guint32 rand2;
	char* _tmp0_;
	char* _tmp1_;
#line 362 "moonshot-id.vala"
	rand1 = g_random_int ();
#line 363 "moonshot-id.vala"
	rand2 = g_random_int ();
#line 1199 "moonshot-id.c"
	result = (_tmp1_ = g_strdup_printf ("%08X.%08X::%s", (guint) rand1, (guint) rand2, _tmp0_ = trust_anchor_format_datetime_now ()), _g_free0 (_tmp0_), _tmp1_);
#line 364 "moonshot-id.vala"
	return result;
#line 1203 "moonshot-id.c"
}


#line 367 "moonshot-id.vala"
gboolean id_card_is_no_identity (IdCard* self) {
#line 1209 "moonshot-id.c"
	gboolean result = FALSE;
#line 367 "moonshot-id.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1213 "moonshot-id.c"
	result = _vala_strcmp0 (self->priv->_display_name, ID_CARD_NO_IDENTITY) == 0;
#line 369 "moonshot-id.vala"
	return result;
#line 1217 "moonshot-id.c"
}


#line 382 "moonshot-id.vala"
gint id_card_Compare (IdCard* self, IdCard* other) {
#line 1223 "moonshot-id.c"
	gint result = 0;
	gint diff;
	gint _tmp0_;
	gint _tmp1_;
	gboolean _tmp2_ = FALSE;
#line 382 "moonshot-id.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 382 "moonshot-id.vala"
	g_return_val_if_fail (other != NULL, 0);
#line 384 "moonshot-id.vala"
	diff = 0;
#line 385 "moonshot-id.vala"
	if (_vala_strcmp0 (self->priv->_display_name, other->priv->_display_name) != 0) {
#line 386 "moonshot-id.vala"
		diff = diff | (1 << ID_CARD_DIFF_FLAGS_DISPLAY_NAME);
#line 1239 "moonshot-id.c"
	}
#line 388 "moonshot-id.vala"
	if (_vala_strcmp0 (id_card_get_username (self), id_card_get_username (other)) != 0) {
#line 389 "moonshot-id.vala"
		diff = diff | (1 << ID_CARD_DIFF_FLAGS_USERNAME);
#line 1245 "moonshot-id.c"
	}
#line 391 "moonshot-id.vala"
	if (_vala_strcmp0 (id_card_get_password (self), id_card_get_password (other)) != 0) {
#line 392 "moonshot-id.vala"
		diff = diff | (1 << ID_CARD_DIFF_FLAGS_PASSWORD);
#line 1251 "moonshot-id.c"
	}
#line 394 "moonshot-id.vala"
	if (_vala_strcmp0 (id_card_get_issuer (self), id_card_get_issuer (other)) != 0) {
#line 395 "moonshot-id.vala"
		diff = diff | (1 << ID_CARD_DIFF_FLAGS_ISSUER);
#line 1257 "moonshot-id.c"
	}
#line 397 "moonshot-id.vala"
	if (CompareRules (id_card_get_rules (self, &_tmp0_), _tmp0_, id_card_get_rules (other, &_tmp1_), _tmp1_) != 0) {
#line 398 "moonshot-id.vala"
		diff = diff | (1 << ID_CARD_DIFF_FLAGS_RULES);
#line 1263 "moonshot-id.c"
	}
#line 400 "moonshot-id.vala"
	if (CompareStringArrayList (self->priv->_services, other->priv->_services) != 0) {
#line 401 "moonshot-id.vala"
		diff = diff | (1 << ID_CARD_DIFF_FLAGS_SERVICES);
#line 1269 "moonshot-id.c"
	}
#line 403 "moonshot-id.vala"
	if (trust_anchor_Compare (id_card_get_trust_anchor (self), id_card_get_trust_anchor (other)) != 0) {
#line 404 "moonshot-id.vala"
		diff = diff | (1 << ID_CARD_DIFF_FLAGS_TRUST_ANCHOR);
#line 1275 "moonshot-id.c"
	}
#line 407 "moonshot-id.vala"
	if (_vala_strcmp0 (self->priv->_display_name, other->priv->_display_name) == 0) {
#line 407 "moonshot-id.vala"
		_tmp2_ = diff != 0;
#line 1281 "moonshot-id.c"
	} else {
#line 407 "moonshot-id.vala"
		_tmp2_ = FALSE;
#line 1285 "moonshot-id.c"
	}
#line 407 "moonshot-id.vala"
	if (_tmp2_) {
#line 1289 "moonshot-id.c"
		char* _tmp3_;
#line 408 "moonshot-id.vala"
		moonshot_logger_trace (id_card_logger, _tmp3_ = g_strdup_printf ("Compare: Two IDs with display_name '%s', but diff_flags=%0x", self->priv->_display_name, (guint) diff), NULL);
#line 1293 "moonshot-id.c"
		_g_free0 (_tmp3_);
	}
	result = diff;
#line 410 "moonshot-id.vala"
	return result;
#line 1299 "moonshot-id.c"
}


#line 413 "moonshot-id.vala"
char* id_card_escape (const char* value) {
#line 1305 "moonshot-id.c"
	char* result = NULL;
	char* _result_;
	char* _tmp0_;
	char* _tmp1_;
	char* _tmp2_;
#line 413 "moonshot-id.vala"
	g_return_val_if_fail (value != NULL, NULL);
#line 416 "moonshot-id.vala"
	_result_ = string_replace (value, "\\@", "@");
#line 417 "moonshot-id.vala"
	_result_ = (_tmp0_ = string_replace (_result_, "\\/", "/"), _g_free0 (_result_), _tmp0_);
#line 420 "moonshot-id.vala"
	_result_ = (_tmp1_ = string_replace (_result_, "@", "\\@"), _g_free0 (_result_), _tmp1_);
#line 421 "moonshot-id.vala"
	_result_ = (_tmp2_ = string_replace (_result_, "/", "\\/"), _g_free0 (_result_), _tmp2_);
#line 1321 "moonshot-id.c"
	result = _result_;
#line 422 "moonshot-id.vala"
	return result;
#line 1325 "moonshot-id.c"
}


#line 425 "moonshot-id.vala"
IdCard* id_card_NewNoIdentity (void) {
#line 1331 "moonshot-id.c"
	IdCard* result = NULL;
	IdCard* card;
	char* _tmp0_;
#line 427 "moonshot-id.vala"
	card = id_card_new ();
#line 428 "moonshot-id.vala"
	id_card_set_display_name (card, ID_CARD_NO_IDENTITY);
#line 429 "moonshot-id.vala"
	card->priv->_nai = (_tmp0_ = g_strdup (""), _g_free0 (card->priv->_nai), _tmp0_);
#line 1341 "moonshot-id.c"
	result = card;
#line 430 "moonshot-id.vala"
	return result;
#line 1345 "moonshot-id.c"
}


static void _vala_array_add2 (Rule** array, int* length, int* size, const Rule* value) {
	if ((*length) == (*size)) {
		*size = (*size) ? (2 * (*size)) : 4;
		*array = g_renew (Rule, *array, *size);
	}
	(*array)[(*length)++] = *value;
}


#line 437 "moonshot-id.vala"
void id_card_add_rule (IdCard* self, Rule* rule) {
#line 1360 "moonshot-id.c"
	Rule _tmp0_ = {0};
	Rule _tmp1_;
#line 437 "moonshot-id.vala"
	g_return_if_fail (self != NULL);
#line 438 "moonshot-id.vala"
	_vala_array_add2 (&self->priv->_rules, &self->priv->_rules_length1, &self->priv->__rules_size_, (_tmp1_ = (rule_copy (rule, &_tmp0_), _tmp0_), &_tmp1_));
#line 1367 "moonshot-id.c"
}


#line 216 "moonshot-id.vala"
IdCard* id_card_construct (GType object_type) {
#line 1373 "moonshot-id.c"
	IdCard * self = NULL;
#line 216 "moonshot-id.vala"
	self = (IdCard*) g_object_new (object_type, NULL);
#line 1377 "moonshot-id.c"
	return self;
}


#line 216 "moonshot-id.vala"
IdCard* id_card_new (void) {
#line 216 "moonshot-id.vala"
	return id_card_construct (TYPE_ID_CARD);
#line 1386 "moonshot-id.c"
}


const char* id_card_get_display_name (IdCard* self) {
	const char* result;
	g_return_val_if_fail (self != NULL, NULL);
	result = self->priv->_display_name;
#line 225 "moonshot-id.vala"
	return result;
#line 1396 "moonshot-id.c"
}


void id_card_set_display_name (IdCard* self, const char* value) {
	char* _tmp0_;
	g_return_if_fail (self != NULL);
	self->priv->_display_name = (_tmp0_ = g_strdup (value), _g_free0 (self->priv->_display_name), _tmp0_);
	g_object_notify ((GObject *) self, "display-name");
}


const char* id_card_get_username (IdCard* self) {
	const char* result;
	g_return_val_if_fail (self != NULL, NULL);
	result = self->priv->_username;
#line 229 "moonshot-id.vala"
	return result;
#line 1414 "moonshot-id.c"
}


void id_card_set_username (IdCard* self, const char* value) {
	char* _tmp0_;
	g_return_if_fail (self != NULL);
#line 232 "moonshot-id.vala"
	self->priv->_username = (_tmp0_ = id_card_escape (value), _g_free0 (self->priv->_username), _tmp0_);
#line 233 "moonshot-id.vala"
	id_card_update_nai (self);
#line 1425 "moonshot-id.c"
	g_object_notify ((GObject *) self, "username");
}


const char* id_card_get_issuer (IdCard* self) {
	const char* result;
	g_return_val_if_fail (self != NULL, NULL);
	result = self->priv->_issuer;
#line 239 "moonshot-id.vala"
	return result;
#line 1436 "moonshot-id.c"
}


void id_card_set_issuer (IdCard* self, const char* value) {
	char* _tmp0_;
	g_return_if_fail (self != NULL);
#line 242 "moonshot-id.vala"
	self->priv->_issuer = (_tmp0_ = id_card_escape (value), _g_free0 (self->priv->_issuer), _tmp0_);
#line 243 "moonshot-id.vala"
	id_card_update_nai (self);
#line 1447 "moonshot-id.c"
	g_object_notify ((GObject *) self, "issuer");
}


const char* id_card_get_password (IdCard* self) {
	const char* result;
	const char* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = NULL;
#line 255 "moonshot-id.vala"
	if (self->priv->_password != NULL) {
#line 255 "moonshot-id.vala"
		_tmp0_ = self->priv->_password;
#line 1461 "moonshot-id.c"
	} else {
#line 255 "moonshot-id.vala"
		_tmp0_ = "";
#line 1465 "moonshot-id.c"
	}
	result = _tmp0_;
#line 255 "moonshot-id.vala"
	return result;
#line 1470 "moonshot-id.c"
}


void id_card_set_password (IdCard* self, const char* value) {
	g_return_if_fail (self != NULL);
#line 258 "moonshot-id.vala"
	if (self->priv->_password != NULL) {
#line 259 "moonshot-id.vala"
		gnome_keyring_memory_free ((void*) self->priv->_password);
#line 260 "moonshot-id.vala"
		self->priv->_password = NULL;
#line 1482 "moonshot-id.c"
	}
#line 262 "moonshot-id.vala"
	if (value != NULL) {
#line 263 "moonshot-id.vala"
		self->priv->_password = gnome_keyring_memory_strdup (value);
#line 1488 "moonshot-id.c"
	}
	g_object_notify ((GObject *) self, "password");
}


const char* id_card_get_mfa_code (IdCard* self) {
	const char* result;
	g_return_val_if_fail (self != NULL, NULL);
	result = self->priv->_mfa_code;
#line 269 "moonshot-id.vala"
	return result;
#line 1500 "moonshot-id.c"
}


void id_card_set_mfa_code (IdCard* self, const char* value) {
	char* _tmp0_;
	g_return_if_fail (self != NULL);
	self->priv->_mfa_code = (_tmp0_ = g_strdup (value), _g_free0 (self->priv->_mfa_code), _tmp0_);
	g_object_notify ((GObject *) self, "mfa-code");
}


Rule* id_card_get_rules (IdCard* self, int* result_length1) {
	Rule* result;
	Rule* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	result = (_tmp0_ = self->priv->_rules, *result_length1 = self->priv->_rules_length1, _tmp0_);
#line 273 "moonshot-id.vala"
	return result;
#line 1519 "moonshot-id.c"
}


static Rule* _vala_array_dup6 (Rule* self, int length) {
	Rule* result;
	int i;
	Rule _tmp0_ = {0};
	result = g_new0 (Rule, length);
	for (i = 0; i < length; i++) {
		result[i] = (rule_copy (&self[i], &_tmp0_), _tmp0_);
	}
	return result;
}


static Rule* _vala_array_dup7 (Rule* self, int length) {
	Rule* result;
	int i;
	Rule _tmp0_ = {0};
	result = g_new0 (Rule, length);
	for (i = 0; i < length; i++) {
		result[i] = (rule_copy (&self[i], &_tmp0_), _tmp0_);
	}
	return result;
}


void id_card_set_rules (IdCard* self, Rule* value, int value_length1) {
	gint _tmp1__length1;
	gint __tmp1__size_;
	Rule* _tmp2_;
	Rule* _tmp0_;
	Rule* _tmp1_;
	Rule* _tmp4_;
	Rule* _tmp5_;
	g_return_if_fail (self != NULL);
	_tmp1_ = (_tmp2_ = (_tmp0_ = value, (_tmp0_ == NULL) ? ((gpointer) _tmp0_) : _vala_array_dup6 (_tmp0_, value_length1)), _tmp1__length1 = value_length1, __tmp1__size_ = _tmp1__length1, _tmp2_);
#line 274 "moonshot-id.vala"
	if (_tmp1_ == NULL) {
#line 1559 "moonshot-id.c"
		Rule* _tmp3_;
#line 274 "moonshot-id.vala"
		_tmp1_ = (_tmp3_ = g_new0 (Rule, 0), _tmp1_ = (_vala_Rule_array_free (_tmp1_, _tmp1__length1), NULL), _tmp1__length1 = 0, __tmp1__size_ = _tmp1__length1, _tmp3_);
#line 1563 "moonshot-id.c"
	}
#line 274 "moonshot-id.vala"
	self->priv->_rules = (_tmp5_ = (_tmp4_ = _tmp1_, (_tmp4_ == NULL) ? ((gpointer) _tmp4_) : _vala_array_dup7 (_tmp4_, _tmp1__length1)), self->priv->_rules = (_vala_Rule_array_free (self->priv->_rules, self->priv->_rules_length1), NULL), self->priv->_rules_length1 = _tmp1__length1, self->priv->__rules_size_ = self->priv->_rules_length1, _tmp5_);
#line 1567 "moonshot-id.c"
	_tmp1_ = (_vala_Rule_array_free (_tmp1_, _tmp1__length1), NULL);
}


GeeList* id_card_get_services (IdCard* self) {
	GeeList* result;
	g_return_val_if_fail (self != NULL, NULL);
	result = self->priv->_services;
#line 280 "moonshot-id.vala"
	return result;
#line 1578 "moonshot-id.c"
}


gboolean id_card_get_temporary (IdCard* self) {
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	result = self->priv->_temporary;
#line 331 "moonshot-id.vala"
	return result;
#line 1588 "moonshot-id.c"
}


void id_card_set_temporary (IdCard* self, gboolean value) {
	g_return_if_fail (self != NULL);
	self->priv->_temporary = value;
	g_object_notify ((GObject *) self, "temporary");
}


TrustAnchor* id_card_get_trust_anchor (IdCard* self) {
	TrustAnchor* result;
	g_return_val_if_fail (self != NULL, NULL);
	result = self->priv->_trust_anchor;
#line 336 "moonshot-id.vala"
	return result;
#line 1605 "moonshot-id.c"
}


const char* id_card_get_nai (IdCard* self) {
	const char* result;
	g_return_val_if_fail (self != NULL, NULL);
	result = self->priv->_nai;
#line 349 "moonshot-id.vala"
	return result;
#line 1615 "moonshot-id.c"
}


static void id_card_set_nai (IdCard* self, const char* value) {
	char* _tmp0_;
	g_return_if_fail (self != NULL);
	self->priv->_nai = (_tmp0_ = g_strdup (value), _g_free0 (self->priv->_nai), _tmp0_);
	g_object_notify ((GObject *) self, "nai");
}


gboolean id_card_get_store_password (IdCard* self) {
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	result = self->priv->_store_password;
#line 351 "moonshot-id.vala"
	return result;
#line 1633 "moonshot-id.c"
}


void id_card_set_store_password (IdCard* self, gboolean value) {
	g_return_if_fail (self != NULL);
	self->priv->_store_password = value;
	g_object_notify ((GObject *) self, "store-password");
}


gboolean id_card_get_has_2fa (IdCard* self) {
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	result = self->priv->_has_2fa;
#line 353 "moonshot-id.vala"
	return result;
#line 1650 "moonshot-id.c"
}


void id_card_set_has_2fa (IdCard* self, gboolean value) {
	g_return_if_fail (self != NULL);
	self->priv->_has_2fa = value;
	g_object_notify ((GObject *) self, "has-2fa");
}


const char* id_card_get_uuid (IdCard* self) {
	const char* result;
	g_return_val_if_fail (self != NULL, NULL);
	result = self->priv->_uuid;
#line 357 "moonshot-id.vala"
	return result;
#line 1667 "moonshot-id.c"
}


static void id_card_class_init (IdCardClass * klass) {
	id_card_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (IdCardPrivate));
	G_OBJECT_CLASS (klass)->get_property = id_card_get_property;
	G_OBJECT_CLASS (klass)->set_property = id_card_set_property;
	G_OBJECT_CLASS (klass)->finalize = id_card_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), ID_CARD_DISPLAY_NAME, g_param_spec_string ("display-name", "display-name", "display-name", NULL, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), ID_CARD_USERNAME, g_param_spec_string ("username", "username", "username", NULL, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), ID_CARD_ISSUER, g_param_spec_string ("issuer", "issuer", "issuer", NULL, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), ID_CARD_PASSWORD, g_param_spec_string ("password", "password", "password", NULL, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), ID_CARD_MFA_CODE, g_param_spec_string ("mfa-code", "mfa-code", "mfa-code", NULL, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), ID_CARD_SERVICES, g_param_spec_object ("services", "services", "services", GEE_TYPE_LIST, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), ID_CARD_TEMPORARY, g_param_spec_boolean ("temporary", "temporary", "temporary", FALSE, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), ID_CARD_TRUST_ANCHOR, g_param_spec_object ("trust-anchor", "trust-anchor", "trust-anchor", TYPE_TRUST_ANCHOR, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), ID_CARD_NAI, g_param_spec_string ("nai", "nai", "nai", NULL, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), ID_CARD_STORE_PASSWORD, g_param_spec_boolean ("store-password", "store-password", "store-password", FALSE, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), ID_CARD_HAS_2FA, g_param_spec_boolean ("has-2fa", "has-2fa", "has-2fa", FALSE, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), ID_CARD_UUID, g_param_spec_string ("uuid", "uuid", "uuid", NULL, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
	id_card_logger = get_logger ("IdCard");
}


static void id_card_instance_init (IdCard * self) {
	self->priv = ID_CARD_GET_PRIVATE (self);
	self->priv->_username = g_strdup ("");
	self->priv->_issuer = g_strdup ("");
	self->priv->_display_name = g_strdup ("");
	self->priv->_mfa_code = NULL;
	self->priv->_rules = g_new0 (Rule, 0);
	self->priv->_rules_length1 = 0;
	self->priv->__rules_size_ = self->priv->_rules_length1;
	self->priv->_services = (GeeList*) gee_array_list_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, g_free, NULL);
	self->priv->_temporary = FALSE;
	self->priv->_trust_anchor = trust_anchor_new_empty ();
	self->priv->_store_password = FALSE;
	self->priv->_has_2fa = FALSE;
	self->priv->_uuid = id_card_generate_uuid ();
}


static void id_card_finalize (GObject* obj) {
	IdCard * self;
	self = ID_CARD (obj);
	{
#line 434 "moonshot-id.vala"
		id_card_set_password (self, NULL);
#line 1717 "moonshot-id.c"
	}
	_g_free0 (self->priv->_username);
	_g_free0 (self->priv->_issuer);
	_g_free0 (self->priv->_display_name);
	_g_free0 (self->priv->_mfa_code);
	self->priv->_rules = (_vala_Rule_array_free (self->priv->_rules, self->priv->_rules_length1), NULL);
	_g_object_unref0 (self->priv->_services);
	_g_object_unref0 (self->priv->_trust_anchor);
	_g_free0 (self->priv->_nai);
	_g_free0 (self->priv->_uuid);
	G_OBJECT_CLASS (id_card_parent_class)->finalize (obj);
}


GType id_card_get_type (void) {
	static volatile gsize id_card_type_id__volatile = 0;
	if (g_once_init_enter (&id_card_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (IdCardClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) id_card_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (IdCard), 0, (GInstanceInitFunc) id_card_instance_init, NULL };
		GType id_card_type_id;
		id_card_type_id = g_type_register_static (G_TYPE_OBJECT, "IdCard", &g_define_type_info, 0);
		g_once_init_leave (&id_card_type_id__volatile, id_card_type_id);
	}
	return id_card_type_id__volatile;
}


static void id_card_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec) {
	IdCard * self;
	self = ID_CARD (object);
	switch (property_id) {
		case ID_CARD_DISPLAY_NAME:
		g_value_set_string (value, id_card_get_display_name (self));
		break;
		case ID_CARD_USERNAME:
		g_value_set_string (value, id_card_get_username (self));
		break;
		case ID_CARD_ISSUER:
		g_value_set_string (value, id_card_get_issuer (self));
		break;
		case ID_CARD_PASSWORD:
		g_value_set_string (value, id_card_get_password (self));
		break;
		case ID_CARD_MFA_CODE:
		g_value_set_string (value, id_card_get_mfa_code (self));
		break;
		case ID_CARD_SERVICES:
		g_value_set_object (value, id_card_get_services (self));
		break;
		case ID_CARD_TEMPORARY:
		g_value_set_boolean (value, id_card_get_temporary (self));
		break;
		case ID_CARD_TRUST_ANCHOR:
		g_value_set_object (value, id_card_get_trust_anchor (self));
		break;
		case ID_CARD_NAI:
		g_value_set_string (value, id_card_get_nai (self));
		break;
		case ID_CARD_STORE_PASSWORD:
		g_value_set_boolean (value, id_card_get_store_password (self));
		break;
		case ID_CARD_HAS_2FA:
		g_value_set_boolean (value, id_card_get_has_2fa (self));
		break;
		case ID_CARD_UUID:
		g_value_set_string (value, id_card_get_uuid (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}


static void id_card_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec) {
	IdCard * self;
	self = ID_CARD (object);
	switch (property_id) {
		case ID_CARD_DISPLAY_NAME:
		id_card_set_display_name (self, g_value_get_string (value));
		break;
		case ID_CARD_USERNAME:
		id_card_set_username (self, g_value_get_string (value));
		break;
		case ID_CARD_ISSUER:
		id_card_set_issuer (self, g_value_get_string (value));
		break;
		case ID_CARD_PASSWORD:
		id_card_set_password (self, g_value_get_string (value));
		break;
		case ID_CARD_MFA_CODE:
		id_card_set_mfa_code (self, g_value_get_string (value));
		break;
		case ID_CARD_TEMPORARY:
		id_card_set_temporary (self, g_value_get_boolean (value));
		break;
		case ID_CARD_NAI:
		id_card_set_nai (self, g_value_get_string (value));
		break;
		case ID_CARD_STORE_PASSWORD:
		id_card_set_store_password (self, g_value_get_boolean (value));
		break;
		case ID_CARD_HAS_2FA:
		id_card_set_has_2fa (self, g_value_get_boolean (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}


#line 442 "moonshot-id.vala"
gint CompareRules (Rule* a, int a_length1, Rule* b, int b_length1) {
#line 1831 "moonshot-id.c"
	gint result = 0;
#line 444 "moonshot-id.vala"
	if (a_length1 != b_length1) {
#line 1835 "moonshot-id.c"
		result = 1;
#line 445 "moonshot-id.vala"
		return result;
#line 1839 "moonshot-id.c"
	}
	{
		gint i;
#line 448 "moonshot-id.vala"
		i = 0;
#line 1845 "moonshot-id.c"
		{
			gboolean _tmp0_;
#line 448 "moonshot-id.vala"
			_tmp0_ = TRUE;
#line 448 "moonshot-id.vala"
			while (TRUE) {
#line 1852 "moonshot-id.c"
				Rule _tmp1_;
				Rule _tmp2_;
#line 448 "moonshot-id.vala"
				if (!_tmp0_) {
#line 448 "moonshot-id.vala"
					i++;
#line 1859 "moonshot-id.c"
				}
#line 448 "moonshot-id.vala"
				_tmp0_ = FALSE;
#line 448 "moonshot-id.vala"
				if (!(i < a_length1)) {
#line 448 "moonshot-id.vala"
					break;
#line 1867 "moonshot-id.c"
				}
#line 449 "moonshot-id.vala"
				if (rule_Compare ((_tmp1_ = a[i], &_tmp1_), (_tmp2_ = b[i], &_tmp2_)) != 0) {
#line 1871 "moonshot-id.c"
					result = 1;
#line 450 "moonshot-id.vala"
					return result;
#line 1875 "moonshot-id.c"
				}
			}
		}
	}
	result = 0;
#line 453 "moonshot-id.vala"
	return result;
#line 1883 "moonshot-id.c"
}


#line 456 "moonshot-id.vala"
gint CompareStringArrayList (GeeList* a, GeeList* b) {
#line 1889 "moonshot-id.c"
	gint result = 0;
#line 456 "moonshot-id.vala"
	g_return_val_if_fail (a != NULL, 0);
#line 456 "moonshot-id.vala"
	g_return_val_if_fail (b != NULL, 0);
#line 458 "moonshot-id.vala"
	if (gee_collection_get_size ((GeeCollection*) a) != gee_collection_get_size ((GeeCollection*) b)) {
#line 1897 "moonshot-id.c"
		result = 1;
#line 459 "moonshot-id.vala"
		return result;
#line 1901 "moonshot-id.c"
	}
	{
		gint i;
#line 462 "moonshot-id.vala"
		i = 0;
#line 1907 "moonshot-id.c"
		{
			gboolean _tmp0_;
#line 462 "moonshot-id.vala"
			_tmp0_ = TRUE;
#line 462 "moonshot-id.vala"
			while (TRUE) {
#line 1914 "moonshot-id.c"
				char* _tmp1_;
				char* _tmp2_;
				gboolean _tmp3_;
#line 462 "moonshot-id.vala"
				if (!_tmp0_) {
#line 462 "moonshot-id.vala"
					i++;
#line 1922 "moonshot-id.c"
				}
#line 462 "moonshot-id.vala"
				_tmp0_ = FALSE;
#line 462 "moonshot-id.vala"
				if (!(i < gee_collection_get_size ((GeeCollection*) a))) {
#line 462 "moonshot-id.vala"
					break;
#line 1930 "moonshot-id.c"
				}
#line 463 "moonshot-id.vala"
				if ((_tmp3_ = _vala_strcmp0 (_tmp1_ = (char*) gee_list_get (a, i), _tmp2_ = (char*) gee_list_get (b, i)) != 0, _g_free0 (_tmp2_), _g_free0 (_tmp1_), _tmp3_)) {
#line 1934 "moonshot-id.c"
					result = 1;
#line 464 "moonshot-id.vala"
					return result;
#line 1938 "moonshot-id.c"
				}
			}
		}
	}
	result = 0;
#line 467 "moonshot-id.vala"
	return result;
#line 1946 "moonshot-id.c"
}


static void _vala_array_destroy (gpointer array, gint array_length, GDestroyNotify destroy_func) {
	if ((array != NULL) && (destroy_func != NULL)) {
		int i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}


static void _vala_array_free (gpointer array, gint array_length, GDestroyNotify destroy_func) {
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}


static int _vala_strcmp0 (const char * str1, const char * str2) {
	if (str1 == NULL) {
		return -(str1 != str2);
	}
	if (str2 == NULL) {
		return str1 != str2;
	}
	return strcmp (str1, str2);
}




