/* moonshot-provisioning-common.c generated by valac 0.10.4, the Vala compiler
 * generated from moonshot-provisioning-common.vala, do not modify */

/*
 * Copyright (c) 2011-2016, JANET(UK)
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 *
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * 3. Neither the name of JANET(UK) nor the names of its contributors
 *    may be used to endorse or promote products derived from this software
 *    without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
 * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
*/

#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <gee.h>
#include <gio/gio.h>


#define WEB_PROVISIONING_TYPE_PARSER (web_provisioning_parser_get_type ())
#define WEB_PROVISIONING_PARSER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), WEB_PROVISIONING_TYPE_PARSER, WebProvisioningParser))
#define WEB_PROVISIONING_PARSER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), WEB_PROVISIONING_TYPE_PARSER, WebProvisioningParserClass))
#define WEB_PROVISIONING_IS_PARSER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), WEB_PROVISIONING_TYPE_PARSER))
#define WEB_PROVISIONING_IS_PARSER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), WEB_PROVISIONING_TYPE_PARSER))
#define WEB_PROVISIONING_PARSER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), WEB_PROVISIONING_TYPE_PARSER, WebProvisioningParserClass))

typedef struct _WebProvisioningParser WebProvisioningParser;
typedef struct _WebProvisioningParserClass WebProvisioningParserClass;
typedef struct _WebProvisioningParserPrivate WebProvisioningParserPrivate;

#define TYPE_ID_CARD (id_card_get_type ())
#define ID_CARD(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_ID_CARD, IdCard))
#define ID_CARD_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_ID_CARD, IdCardClass))
#define IS_ID_CARD(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_ID_CARD))
#define IS_ID_CARD_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_ID_CARD))
#define ID_CARD_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_ID_CARD, IdCardClass))

typedef struct _IdCard IdCard;
typedef struct _IdCardClass IdCardClass;

#define TYPE_MOONSHOT_LOGGER (moonshot_logger_get_type ())
#define MOONSHOT_LOGGER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_MOONSHOT_LOGGER, MoonshotLogger))
#define MOONSHOT_LOGGER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_MOONSHOT_LOGGER, MoonshotLoggerClass))
#define IS_MOONSHOT_LOGGER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_MOONSHOT_LOGGER))
#define IS_MOONSHOT_LOGGER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_MOONSHOT_LOGGER))
#define MOONSHOT_LOGGER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_MOONSHOT_LOGGER, MoonshotLoggerClass))

typedef struct _MoonshotLogger MoonshotLogger;
typedef struct _MoonshotLoggerClass MoonshotLoggerClass;
#define _g_markup_parse_context_free0(var) ((var == NULL) ? NULL : (var = (g_markup_parse_context_free (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

#define TYPE_RULE (rule_get_type ())
typedef struct _Rule Rule;

#define TYPE_TRUST_ANCHOR (trust_anchor_get_type ())
#define TRUST_ANCHOR(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_TRUST_ANCHOR, TrustAnchor))
#define TRUST_ANCHOR_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_TRUST_ANCHOR, TrustAnchorClass))
#define IS_TRUST_ANCHOR(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_TRUST_ANCHOR))
#define IS_TRUST_ANCHOR_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_TRUST_ANCHOR))
#define TRUST_ANCHOR_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_TRUST_ANCHOR, TrustAnchorClass))

typedef struct _TrustAnchor TrustAnchor;
typedef struct _TrustAnchorClass TrustAnchorClass;
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))

struct _WebProvisioningParser {
	GObject parent_instance;
	WebProvisioningParserPrivate * priv;
};

struct _WebProvisioningParserClass {
	GObjectClass parent_class;
};

struct _WebProvisioningParserPrivate {
	GMarkupParseContext* ctx;
	char* text;
	char* path;
	char* ta_ca_cert;
	char* ta_server_cert;
	char* ta_subject;
	char* ta_subject_alt;
	IdCard* card;
	IdCard** _cards;
	gint _cards_length1;
	gint __cards_size_;
};

struct _Rule {
	char* pattern;
	char* always_confirm;
};


static MoonshotLogger* web_provisioning_parser_logger;
static MoonshotLogger* web_provisioning_parser_logger = NULL;
static gpointer web_provisioning_parser_parent_class = NULL;

gboolean web_provisioning_check_stack (GSList* stack, char** reference, int reference_length1);
gboolean web_provisioning_always_confirm_handler (GSList* stack);
gboolean web_provisioning_pattern_handler (GSList* stack);
gboolean web_provisioning_server_cert_handler (GSList* stack);
gboolean web_provisioning_subject_alt_handler (GSList* stack);
gboolean web_provisioning_subject_handler (GSList* stack);
gboolean web_provisioning_ca_cert_handler (GSList* stack);
gboolean web_provisioning_realm_handler (GSList* stack);
gboolean web_provisioning_password_handler (GSList* stack);
gboolean web_provisioning_user_handler (GSList* stack);
gboolean web_provisioning_display_name_handler (GSList* stack);
GType web_provisioning_parser_get_type (void) G_GNUC_CONST;
GType id_card_get_type (void) G_GNUC_CONST;
#define WEB_PROVISIONING_PARSER_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), WEB_PROVISIONING_TYPE_PARSER, WebProvisioningParserPrivate))
enum  {
	WEB_PROVISIONING_PARSER_DUMMY_PROPERTY
};
MoonshotLogger* moonshot_logger_new (const char* name);
MoonshotLogger* moonshot_logger_construct (GType object_type, const char* name);
GType moonshot_logger_get_type (void) G_GNUC_CONST;
static void web_provisioning_parser_start_element_func (WebProvisioningParser* self, GMarkupParseContext* context, const char* element_name, char** attribute_names, int attribute_names_length1, char** attribute_values, int attribute_values_length1, GError** error);
static void _web_provisioning_parser_start_element_func_gmarkup_parser_start_element_func (GMarkupParseContext* context, const char* element_name, char** attribute_names, char** attribute_values, gpointer self, GError** error);
static void web_provisioning_parser_end_element_func (WebProvisioningParser* self, GMarkupParseContext* context, const char* element_name, GError** error);
static void _web_provisioning_parser_end_element_func_gmarkup_parser_end_element_func (GMarkupParseContext* context, const char* element_name, gpointer self, GError** error);
static void web_provisioning_parser_text_element_func (WebProvisioningParser* self, GMarkupParseContext* context, const char* text, gsize text_len, GError** error);
static void _web_provisioning_parser_text_element_func_gmarkup_parser_text_func (GMarkupParseContext* context, const char* text, gsize text_len, gpointer self, GError** error);
IdCard* id_card_new (void);
IdCard* id_card_construct (GType object_type);
static void _vala_array_add1 (IdCard*** array, int* length, int* size, IdCard* value);
GType rule_get_type (void) G_GNUC_CONST;
Rule* rule_dup (const Rule* self);
void rule_free (Rule* self);
void rule_copy (const Rule* self, Rule* dest);
void rule_destroy (Rule* self);
void id_card_add_rule (IdCard* self, Rule* rule);
TrustAnchor* trust_anchor_new (const char* ca_cert, const char* server_cert, const char* subject, const char* subject_alt);
TrustAnchor* trust_anchor_construct (GType object_type, const char* ca_cert, const char* server_cert, const char* subject, const char* subject_alt);
GType trust_anchor_get_type (void) G_GNUC_CONST;
void id_card_set_trust_anchor_from_store (IdCard* self, TrustAnchor* ta);
void id_card_set_display_name (IdCard* self, const char* value);
void id_card_set_username (IdCard* self, const char* value);
void id_card_set_password (IdCard* self, const char* value);
const char* id_card_get_password (IdCard* self);
void id_card_set_store_password (IdCard* self, gboolean value);
void id_card_set_issuer (IdCard* self, const char* value);
GeeList* id_card_get_services (IdCard* self);
Rule* id_card_get_rules (IdCard* self, int* result_length1);
static Rule* _vala_array_dup2 (Rule* self, int length);
static void _vala_Rule_array_free (Rule* array, gint array_length);
static Rule* _vala_array_dup3 (Rule* self, int length);
WebProvisioningParser* web_provisioning_parser_new (const char* path);
WebProvisioningParser* web_provisioning_parser_construct (GType object_type, const char* path);
void moonshot_logger_error (MoonshotLogger* self, const char* message, GError* e);
gboolean web_provisioning_parser_parse (WebProvisioningParser* self);
IdCard** web_provisioning_parser_get_cards (WebProvisioningParser* self, int* result_length1);
static void web_provisioning_parser_set_cards (WebProvisioningParser* self, IdCard** value, int value_length1);
static IdCard** _vala_array_dup4 (IdCard** self, int length);
static IdCard** _vala_array_dup5 (IdCard** self, int length);
static void web_provisioning_parser_finalize (GObject* obj);
static void web_provisioning_parser_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec);
static void web_provisioning_parser_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec);
static void _vala_array_destroy (gpointer array, gint array_length, GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array, gint array_length, GDestroyNotify destroy_func);
static gint _vala_array_length (gpointer array);
static int _vala_strcmp0 (const char * str1, const char * str2);

static const GMarkupParser WEB_PROVISIONING_PARSER_parser = {_web_provisioning_parser_start_element_func_gmarkup_parser_start_element_func, _web_provisioning_parser_end_element_func_gmarkup_parser_end_element_func, _web_provisioning_parser_text_element_func_gmarkup_parser_text_func, NULL, NULL};


#line 37 "moonshot-provisioning-common.vala"
gboolean web_provisioning_check_stack (GSList* stack, char** reference, int reference_length1) {
#line 197 "moonshot-provisioning-common.c"
	gboolean result = FALSE;
#line 39 "moonshot-provisioning-common.vala"
	if (g_slist_length (stack) < reference_length1) {
#line 201 "moonshot-provisioning-common.c"
		result = FALSE;
#line 40 "moonshot-provisioning-common.vala"
		return result;
#line 205 "moonshot-provisioning-common.c"
	}
	{
		gint i;
#line 42 "moonshot-provisioning-common.vala"
		i = 0;
#line 211 "moonshot-provisioning-common.c"
		{
			gboolean _tmp0_;
#line 42 "moonshot-provisioning-common.vala"
			_tmp0_ = TRUE;
#line 42 "moonshot-provisioning-common.vala"
			while (TRUE) {
#line 42 "moonshot-provisioning-common.vala"
				if (!_tmp0_) {
#line 42 "moonshot-provisioning-common.vala"
					i++;
#line 222 "moonshot-provisioning-common.c"
				}
#line 42 "moonshot-provisioning-common.vala"
				_tmp0_ = FALSE;
#line 42 "moonshot-provisioning-common.vala"
				if (!(i < reference_length1)) {
#line 42 "moonshot-provisioning-common.vala"
					break;
#line 230 "moonshot-provisioning-common.c"
				}
#line 44 "moonshot-provisioning-common.vala"
				if (_vala_strcmp0 ((const char*) g_slist_nth_data (stack, (guint) i), reference[i]) != 0) {
#line 234 "moonshot-provisioning-common.c"
					result = FALSE;
#line 45 "moonshot-provisioning-common.vala"
					return result;
#line 238 "moonshot-provisioning-common.c"
				}
			}
		}
	}
	result = TRUE;
#line 48 "moonshot-provisioning-common.vala"
	return result;
#line 246 "moonshot-provisioning-common.c"
}


#line 51 "moonshot-provisioning-common.vala"
gboolean web_provisioning_always_confirm_handler (GSList* stack) {
#line 252 "moonshot-provisioning-common.c"
	gboolean result = FALSE;
	gint always_confirm_path_length1;
	gint _always_confirm_path_size_;
	char** _tmp1_;
	char** _tmp0_ = NULL;
	char** always_confirm_path;
	always_confirm_path = (_tmp1_ = (_tmp0_ = g_new0 (char*, 5 + 1), _tmp0_[0] = g_strdup ("always-confirm"), _tmp0_[1] = g_strdup ("rule"), _tmp0_[2] = g_strdup ("selection-rules"), _tmp0_[3] = g_strdup ("identity"), _tmp0_[4] = g_strdup ("identities"), _tmp0_), always_confirm_path_length1 = 5, _always_confirm_path_size_ = always_confirm_path_length1, _tmp1_);
	result = web_provisioning_check_stack (stack, always_confirm_path, always_confirm_path_length1);
	always_confirm_path = (_vala_array_free (always_confirm_path, always_confirm_path_length1, (GDestroyNotify) g_free), NULL);
#line 55 "moonshot-provisioning-common.vala"
	return result;
#line 264 "moonshot-provisioning-common.c"
}


#line 58 "moonshot-provisioning-common.vala"
gboolean web_provisioning_pattern_handler (GSList* stack) {
#line 270 "moonshot-provisioning-common.c"
	gboolean result = FALSE;
	gint pattern_path_length1;
	gint _pattern_path_size_;
	char** _tmp1_;
	char** _tmp0_ = NULL;
	char** pattern_path;
	pattern_path = (_tmp1_ = (_tmp0_ = g_new0 (char*, 5 + 1), _tmp0_[0] = g_strdup ("pattern"), _tmp0_[1] = g_strdup ("rule"), _tmp0_[2] = g_strdup ("selection-rules"), _tmp0_[3] = g_strdup ("identity"), _tmp0_[4] = g_strdup ("identities"), _tmp0_), pattern_path_length1 = 5, _pattern_path_size_ = pattern_path_length1, _tmp1_);
	result = web_provisioning_check_stack (stack, pattern_path, pattern_path_length1);
	pattern_path = (_vala_array_free (pattern_path, pattern_path_length1, (GDestroyNotify) g_free), NULL);
#line 63 "moonshot-provisioning-common.vala"
	return result;
#line 282 "moonshot-provisioning-common.c"
}


#line 66 "moonshot-provisioning-common.vala"
gboolean web_provisioning_server_cert_handler (GSList* stack) {
#line 288 "moonshot-provisioning-common.c"
	gboolean result = FALSE;
	gint server_cert_path_length1;
	gint _server_cert_path_size_;
	char** _tmp1_;
	char** _tmp0_ = NULL;
	char** server_cert_path;
	server_cert_path = (_tmp1_ = (_tmp0_ = g_new0 (char*, 4 + 1), _tmp0_[0] = g_strdup ("server-cert"), _tmp0_[1] = g_strdup ("trust-anchor"), _tmp0_[2] = g_strdup ("identity"), _tmp0_[3] = g_strdup ("identities"), _tmp0_), server_cert_path_length1 = 4, _server_cert_path_size_ = server_cert_path_length1, _tmp1_);
	result = web_provisioning_check_stack (stack, server_cert_path, server_cert_path_length1);
	server_cert_path = (_vala_array_free (server_cert_path, server_cert_path_length1, (GDestroyNotify) g_free), NULL);
#line 70 "moonshot-provisioning-common.vala"
	return result;
#line 300 "moonshot-provisioning-common.c"
}


#line 73 "moonshot-provisioning-common.vala"
gboolean web_provisioning_subject_alt_handler (GSList* stack) {
#line 306 "moonshot-provisioning-common.c"
	gboolean result = FALSE;
	gint subject_alt_path_length1;
	gint _subject_alt_path_size_;
	char** _tmp1_;
	char** _tmp0_ = NULL;
	char** subject_alt_path;
	subject_alt_path = (_tmp1_ = (_tmp0_ = g_new0 (char*, 4 + 1), _tmp0_[0] = g_strdup ("subject-alt"), _tmp0_[1] = g_strdup ("trust-anchor"), _tmp0_[2] = g_strdup ("identity"), _tmp0_[3] = g_strdup ("identities"), _tmp0_), subject_alt_path_length1 = 4, _subject_alt_path_size_ = subject_alt_path_length1, _tmp1_);
	result = web_provisioning_check_stack (stack, subject_alt_path, subject_alt_path_length1);
	subject_alt_path = (_vala_array_free (subject_alt_path, subject_alt_path_length1, (GDestroyNotify) g_free), NULL);
#line 77 "moonshot-provisioning-common.vala"
	return result;
#line 318 "moonshot-provisioning-common.c"
}


#line 80 "moonshot-provisioning-common.vala"
gboolean web_provisioning_subject_handler (GSList* stack) {
#line 324 "moonshot-provisioning-common.c"
	gboolean result = FALSE;
	gint subject_path_length1;
	gint _subject_path_size_;
	char** _tmp1_;
	char** _tmp0_ = NULL;
	char** subject_path;
	subject_path = (_tmp1_ = (_tmp0_ = g_new0 (char*, 4 + 1), _tmp0_[0] = g_strdup ("subject"), _tmp0_[1] = g_strdup ("trust-anchor"), _tmp0_[2] = g_strdup ("identity"), _tmp0_[3] = g_strdup ("identities"), _tmp0_), subject_path_length1 = 4, _subject_path_size_ = subject_path_length1, _tmp1_);
	result = web_provisioning_check_stack (stack, subject_path, subject_path_length1);
	subject_path = (_vala_array_free (subject_path, subject_path_length1, (GDestroyNotify) g_free), NULL);
#line 84 "moonshot-provisioning-common.vala"
	return result;
#line 336 "moonshot-provisioning-common.c"
}


#line 87 "moonshot-provisioning-common.vala"
gboolean web_provisioning_ca_cert_handler (GSList* stack) {
#line 342 "moonshot-provisioning-common.c"
	gboolean result = FALSE;
	gint ca_path_length1;
	gint _ca_path_size_;
	char** _tmp1_;
	char** _tmp0_ = NULL;
	char** ca_path;
	ca_path = (_tmp1_ = (_tmp0_ = g_new0 (char*, 4 + 1), _tmp0_[0] = g_strdup ("ca-cert"), _tmp0_[1] = g_strdup ("trust-anchor"), _tmp0_[2] = g_strdup ("identity"), _tmp0_[3] = g_strdup ("identities"), _tmp0_), ca_path_length1 = 4, _ca_path_size_ = ca_path_length1, _tmp1_);
	result = web_provisioning_check_stack (stack, ca_path, ca_path_length1);
	ca_path = (_vala_array_free (ca_path, ca_path_length1, (GDestroyNotify) g_free), NULL);
#line 91 "moonshot-provisioning-common.vala"
	return result;
#line 354 "moonshot-provisioning-common.c"
}


#line 94 "moonshot-provisioning-common.vala"
gboolean web_provisioning_realm_handler (GSList* stack) {
#line 360 "moonshot-provisioning-common.c"
	gboolean result = FALSE;
	gint realm_path_length1;
	gint _realm_path_size_;
	char** _tmp1_;
	char** _tmp0_ = NULL;
	char** realm_path;
	realm_path = (_tmp1_ = (_tmp0_ = g_new0 (char*, 3 + 1), _tmp0_[0] = g_strdup ("realm"), _tmp0_[1] = g_strdup ("identity"), _tmp0_[2] = g_strdup ("identities"), _tmp0_), realm_path_length1 = 3, _realm_path_size_ = realm_path_length1, _tmp1_);
	result = web_provisioning_check_stack (stack, realm_path, realm_path_length1);
	realm_path = (_vala_array_free (realm_path, realm_path_length1, (GDestroyNotify) g_free), NULL);
#line 98 "moonshot-provisioning-common.vala"
	return result;
#line 372 "moonshot-provisioning-common.c"
}


#line 101 "moonshot-provisioning-common.vala"
gboolean web_provisioning_password_handler (GSList* stack) {
#line 378 "moonshot-provisioning-common.c"
	gboolean result = FALSE;
	gint password_path_length1;
	gint _password_path_size_;
	char** _tmp1_;
	char** _tmp0_ = NULL;
	char** password_path;
	password_path = (_tmp1_ = (_tmp0_ = g_new0 (char*, 3 + 1), _tmp0_[0] = g_strdup ("password"), _tmp0_[1] = g_strdup ("identity"), _tmp0_[2] = g_strdup ("identities"), _tmp0_), password_path_length1 = 3, _password_path_size_ = password_path_length1, _tmp1_);
	result = web_provisioning_check_stack (stack, password_path, password_path_length1);
	password_path = (_vala_array_free (password_path, password_path_length1, (GDestroyNotify) g_free), NULL);
#line 105 "moonshot-provisioning-common.vala"
	return result;
#line 390 "moonshot-provisioning-common.c"
}


#line 108 "moonshot-provisioning-common.vala"
gboolean web_provisioning_user_handler (GSList* stack) {
#line 396 "moonshot-provisioning-common.c"
	gboolean result = FALSE;
	gint user_path_length1;
	gint _user_path_size_;
	char** _tmp1_;
	char** _tmp0_ = NULL;
	char** user_path;
	user_path = (_tmp1_ = (_tmp0_ = g_new0 (char*, 3 + 1), _tmp0_[0] = g_strdup ("user"), _tmp0_[1] = g_strdup ("identity"), _tmp0_[2] = g_strdup ("identities"), _tmp0_), user_path_length1 = 3, _user_path_size_ = user_path_length1, _tmp1_);
	result = web_provisioning_check_stack (stack, user_path, user_path_length1);
	user_path = (_vala_array_free (user_path, user_path_length1, (GDestroyNotify) g_free), NULL);
#line 112 "moonshot-provisioning-common.vala"
	return result;
#line 408 "moonshot-provisioning-common.c"
}


#line 115 "moonshot-provisioning-common.vala"
gboolean web_provisioning_display_name_handler (GSList* stack) {
#line 414 "moonshot-provisioning-common.c"
	gboolean result = FALSE;
	gint display_name_path_length1;
	gint _display_name_path_size_;
	char** _tmp1_;
	char** _tmp0_ = NULL;
	char** display_name_path;
	display_name_path = (_tmp1_ = (_tmp0_ = g_new0 (char*, 3 + 1), _tmp0_[0] = g_strdup ("display-name"), _tmp0_[1] = g_strdup ("identity"), _tmp0_[2] = g_strdup ("identities"), _tmp0_), display_name_path_length1 = 3, _display_name_path_size_ = display_name_path_length1, _tmp1_);
	result = web_provisioning_check_stack (stack, display_name_path, display_name_path_length1);
	display_name_path = (_vala_array_free (display_name_path, display_name_path_length1, (GDestroyNotify) g_free), NULL);
#line 119 "moonshot-provisioning-common.vala"
	return result;
#line 426 "moonshot-provisioning-common.c"
}


#line 126 "moonshot-provisioning-common.vala"
static void _web_provisioning_parser_start_element_func_gmarkup_parser_start_element_func (GMarkupParseContext* context, const char* element_name, char** attribute_names, char** attribute_values, gpointer self, GError** error) {
#line 432 "moonshot-provisioning-common.c"
	web_provisioning_parser_start_element_func (self, context, element_name, attribute_names, _vala_array_length (attribute_names), attribute_values, _vala_array_length (attribute_values), error);
}


#line 147 "moonshot-provisioning-common.vala"
static void _web_provisioning_parser_end_element_func_gmarkup_parser_end_element_func (GMarkupParseContext* context, const char* element_name, gpointer self, GError** error) {
#line 439 "moonshot-provisioning-common.c"
	web_provisioning_parser_end_element_func (self, context, element_name, error);
}


#line 163 "moonshot-provisioning-common.vala"
static void _web_provisioning_parser_text_element_func_gmarkup_parser_text_func (GMarkupParseContext* context, const char* text, gsize text_len, gpointer self, GError** error) {
#line 446 "moonshot-provisioning-common.c"
	web_provisioning_parser_text_element_func (self, context, text, text_len, error);
}


static gpointer _g_object_ref0 (gpointer self) {
	return self ? g_object_ref (self) : NULL;
}


static void _vala_array_add1 (IdCard*** array, int* length, int* size, IdCard* value) {
	if ((*length) == (*size)) {
		*size = (*size) ? (2 * (*size)) : 4;
		*array = g_renew (IdCard*, *array, (*size) + 1);
	}
	(*array)[(*length)++] = value;
	(*array)[*length] = NULL;
}


#line 126 "moonshot-provisioning-common.vala"
static void web_provisioning_parser_start_element_func (WebProvisioningParser* self, GMarkupParseContext* context, const char* element_name, char** attribute_names, int attribute_names_length1, char** attribute_values, int attribute_values_length1, GError** error) {
#line 126 "moonshot-provisioning-common.vala"
	g_return_if_fail (self != NULL);
#line 126 "moonshot-provisioning-common.vala"
	g_return_if_fail (context != NULL);
#line 126 "moonshot-provisioning-common.vala"
	g_return_if_fail (element_name != NULL);
#line 131 "moonshot-provisioning-common.vala"
	if (_vala_strcmp0 (element_name, "identity") == 0) {
#line 476 "moonshot-provisioning-common.c"
		IdCard* _tmp0_;
		char* _tmp1_;
		char* _tmp2_;
		char* _tmp3_;
		char* _tmp4_;
#line 133 "moonshot-provisioning-common.vala"
		self->priv->card = (_tmp0_ = id_card_new (), _g_object_unref0 (self->priv->card), _tmp0_);
#line 134 "moonshot-provisioning-common.vala"
		_vala_array_add1 (&self->priv->_cards, &self->priv->_cards_length1, &self->priv->__cards_size_, _g_object_ref0 (self->priv->card));
#line 136 "moonshot-provisioning-common.vala"
		self->priv->ta_ca_cert = (_tmp1_ = g_strdup (""), _g_free0 (self->priv->ta_ca_cert), _tmp1_);
#line 137 "moonshot-provisioning-common.vala"
		self->priv->ta_server_cert = (_tmp2_ = g_strdup (""), _g_free0 (self->priv->ta_server_cert), _tmp2_);
#line 138 "moonshot-provisioning-common.vala"
		self->priv->ta_subject = (_tmp3_ = g_strdup (""), _g_free0 (self->priv->ta_subject), _tmp3_);
#line 139 "moonshot-provisioning-common.vala"
		self->priv->ta_subject_alt = (_tmp4_ = g_strdup (""), _g_free0 (self->priv->ta_subject_alt), _tmp4_);
#line 494 "moonshot-provisioning-common.c"
	} else {
#line 141 "moonshot-provisioning-common.vala"
		if (_vala_strcmp0 (element_name, "rule") == 0) {
#line 498 "moonshot-provisioning-common.c"
			Rule _tmp5_ = {0};
			Rule _tmp6_;
			Rule _tmp7_;
#line 143 "moonshot-provisioning-common.vala"
			id_card_add_rule (self->priv->card, (_tmp7_ = _tmp6_ = (memset (&_tmp5_, 0, sizeof (Rule)), _tmp5_), &_tmp7_));
#line 504 "moonshot-provisioning-common.c"
			rule_destroy (&_tmp6_);
		}
	}
}


#line 147 "moonshot-provisioning-common.vala"
static void web_provisioning_parser_end_element_func (WebProvisioningParser* self, GMarkupParseContext* context, const char* element_name, GError** error) {
#line 147 "moonshot-provisioning-common.vala"
	g_return_if_fail (self != NULL);
#line 147 "moonshot-provisioning-common.vala"
	g_return_if_fail (context != NULL);
#line 147 "moonshot-provisioning-common.vala"
	g_return_if_fail (element_name != NULL);
#line 150 "moonshot-provisioning-common.vala"
	if (_vala_strcmp0 (element_name, "identity") == 0) {
#line 521 "moonshot-provisioning-common.c"
		gboolean _tmp0_ = FALSE;
#line 152 "moonshot-provisioning-common.vala"
		if (_vala_strcmp0 (self->priv->ta_ca_cert, "") != 0) {
#line 152 "moonshot-provisioning-common.vala"
			_tmp0_ = TRUE;
#line 527 "moonshot-provisioning-common.c"
		} else {
#line 152 "moonshot-provisioning-common.vala"
			_tmp0_ = _vala_strcmp0 (self->priv->ta_server_cert, "") != 0;
#line 531 "moonshot-provisioning-common.c"
		}
#line 152 "moonshot-provisioning-common.vala"
		if (_tmp0_) {
#line 535 "moonshot-provisioning-common.c"
			TrustAnchor* ta;
#line 153 "moonshot-provisioning-common.vala"
			ta = trust_anchor_new (self->priv->ta_ca_cert, self->priv->ta_server_cert, self->priv->ta_subject, self->priv->ta_subject_alt);
#line 158 "moonshot-provisioning-common.vala"
			id_card_set_trust_anchor_from_store (self->priv->card, ta);
#line 541 "moonshot-provisioning-common.c"
			_g_object_unref0 (ta);
		}
	}
}


static Rule* _vala_array_dup2 (Rule* self, int length) {
	Rule* result;
	int i;
	Rule _tmp0_ = {0};
	result = g_new0 (Rule, length);
	for (i = 0; i < length; i++) {
		result[i] = (rule_copy (&self[i], &_tmp0_), _tmp0_);
	}
	return result;
}


static void _vala_Rule_array_free (Rule* array, gint array_length) {
	if (array != NULL) {
		int i;
		for (i = 0; i < array_length; i = i + 1) {
			rule_destroy (&array[i]);
		}
	}
	g_free (array);
}


static Rule* _vala_array_dup3 (Rule* self, int length) {
	Rule* result;
	int i;
	Rule _tmp0_ = {0};
	result = g_new0 (Rule, length);
	for (i = 0; i < length; i++) {
		result[i] = (rule_copy (&self[i], &_tmp0_), _tmp0_);
	}
	return result;
}


#line 163 "moonshot-provisioning-common.vala"
static void web_provisioning_parser_text_element_func (WebProvisioningParser* self, GMarkupParseContext* context, const char* text, gsize text_len, GError** error) {
#line 585 "moonshot-provisioning-common.c"
	GSList* stack;
	gboolean _tmp0_ = FALSE;
#line 163 "moonshot-provisioning-common.vala"
	g_return_if_fail (self != NULL);
#line 163 "moonshot-provisioning-common.vala"
	g_return_if_fail (context != NULL);
#line 163 "moonshot-provisioning-common.vala"
	g_return_if_fail (text != NULL);
#line 167 "moonshot-provisioning-common.vala"
	stack = g_markup_parse_context_get_element_stack (context);
#line 169 "moonshot-provisioning-common.vala"
	if (text_len < 1) {
#line 170 "moonshot-provisioning-common.vala"
		return;
#line 600 "moonshot-provisioning-common.c"
	}
#line 172 "moonshot-provisioning-common.vala"
	if (_vala_strcmp0 ((const char*) g_slist_nth_data (stack, (guint) 0), "display-name") == 0) {
#line 172 "moonshot-provisioning-common.vala"
		_tmp0_ = web_provisioning_display_name_handler (stack);
#line 606 "moonshot-provisioning-common.c"
	} else {
#line 172 "moonshot-provisioning-common.vala"
		_tmp0_ = FALSE;
#line 610 "moonshot-provisioning-common.c"
	}
#line 172 "moonshot-provisioning-common.vala"
	if (_tmp0_) {
#line 174 "moonshot-provisioning-common.vala"
		id_card_set_display_name (self->priv->card, text);
#line 616 "moonshot-provisioning-common.c"
	} else {
		gboolean _tmp1_ = FALSE;
#line 176 "moonshot-provisioning-common.vala"
		if (_vala_strcmp0 ((const char*) g_slist_nth_data (stack, (guint) 0), "user") == 0) {
#line 176 "moonshot-provisioning-common.vala"
			_tmp1_ = web_provisioning_user_handler (stack);
#line 623 "moonshot-provisioning-common.c"
		} else {
#line 176 "moonshot-provisioning-common.vala"
			_tmp1_ = FALSE;
#line 627 "moonshot-provisioning-common.c"
		}
#line 176 "moonshot-provisioning-common.vala"
		if (_tmp1_) {
#line 178 "moonshot-provisioning-common.vala"
			id_card_set_username (self->priv->card, text);
#line 633 "moonshot-provisioning-common.c"
		} else {
			gboolean _tmp2_ = FALSE;
#line 180 "moonshot-provisioning-common.vala"
			if (_vala_strcmp0 ((const char*) g_slist_nth_data (stack, (guint) 0), "password") == 0) {
#line 180 "moonshot-provisioning-common.vala"
				_tmp2_ = web_provisioning_password_handler (stack);
#line 640 "moonshot-provisioning-common.c"
			} else {
#line 180 "moonshot-provisioning-common.vala"
				_tmp2_ = FALSE;
#line 644 "moonshot-provisioning-common.c"
			}
#line 180 "moonshot-provisioning-common.vala"
			if (_tmp2_) {
#line 648 "moonshot-provisioning-common.c"
				gboolean _tmp3_ = FALSE;
#line 182 "moonshot-provisioning-common.vala"
				id_card_set_password (self->priv->card, text);
#line 183 "moonshot-provisioning-common.vala"
				if (id_card_get_password (self->priv->card) != NULL) {
#line 183 "moonshot-provisioning-common.vala"
					_tmp3_ = _vala_strcmp0 (id_card_get_password (self->priv->card), "") != 0;
#line 656 "moonshot-provisioning-common.c"
				} else {
#line 183 "moonshot-provisioning-common.vala"
					_tmp3_ = FALSE;
#line 660 "moonshot-provisioning-common.c"
				}
#line 183 "moonshot-provisioning-common.vala"
				if (_tmp3_) {
#line 184 "moonshot-provisioning-common.vala"
					id_card_set_store_password (self->priv->card, TRUE);
#line 666 "moonshot-provisioning-common.c"
				}
			} else {
				gboolean _tmp4_ = FALSE;
#line 186 "moonshot-provisioning-common.vala"
				if (_vala_strcmp0 ((const char*) g_slist_nth_data (stack, (guint) 0), "realm") == 0) {
#line 186 "moonshot-provisioning-common.vala"
					_tmp4_ = web_provisioning_realm_handler (stack);
#line 674 "moonshot-provisioning-common.c"
				} else {
#line 186 "moonshot-provisioning-common.vala"
					_tmp4_ = FALSE;
#line 678 "moonshot-provisioning-common.c"
				}
#line 186 "moonshot-provisioning-common.vala"
				if (_tmp4_) {
#line 188 "moonshot-provisioning-common.vala"
					id_card_set_issuer (self->priv->card, text);
#line 684 "moonshot-provisioning-common.c"
				} else {
#line 190 "moonshot-provisioning-common.vala"
					if (_vala_strcmp0 ((const char*) g_slist_nth_data (stack, (guint) 0), "service") == 0) {
#line 192 "moonshot-provisioning-common.vala"
						gee_collection_add ((GeeCollection*) id_card_get_services (self->priv->card), text);
#line 690 "moonshot-provisioning-common.c"
					} else {
						gboolean _tmp5_ = FALSE;
#line 196 "moonshot-provisioning-common.vala"
						if (_vala_strcmp0 ((const char*) g_slist_nth_data (stack, (guint) 0), "pattern") == 0) {
#line 196 "moonshot-provisioning-common.vala"
							_tmp5_ = web_provisioning_pattern_handler (stack);
#line 697 "moonshot-provisioning-common.c"
						} else {
#line 196 "moonshot-provisioning-common.vala"
							_tmp5_ = FALSE;
#line 701 "moonshot-provisioning-common.c"
						}
#line 196 "moonshot-provisioning-common.vala"
						if (_tmp5_) {
#line 705 "moonshot-provisioning-common.c"
							gint temp_length1;
							gint _temp_size_;
							Rule* _tmp8_;
							gint _tmp6_;
							Rule* _tmp7_;
							Rule* temp;
							gint _tmp9_;
							char* *_tmp10_;
							char* _tmp11_;
							temp = (_tmp8_ = (_tmp7_ = id_card_get_rules (self->priv->card, &_tmp6_), (_tmp7_ == NULL) ? ((gpointer) _tmp7_) : _vala_array_dup2 (_tmp7_, _tmp6_)), temp_length1 = _tmp6_, _temp_size_ = temp_length1, _tmp8_);
#line 200 "moonshot-provisioning-common.vala"
							_tmp10_ = &id_card_get_rules (self->priv->card, &_tmp9_)[temp_length1 - 1].pattern;
#line 200 "moonshot-provisioning-common.vala"
							(*_tmp10_) = (_tmp11_ = g_strdup (text), _g_free0 ((*_tmp10_)), _tmp11_);
#line 720 "moonshot-provisioning-common.c"
							temp = (_vala_Rule_array_free (temp, temp_length1), NULL);
						} else {
							gboolean _tmp12_ = FALSE;
#line 202 "moonshot-provisioning-common.vala"
							if (_vala_strcmp0 ((const char*) g_slist_nth_data (stack, (guint) 0), "always-confirm") == 0) {
#line 202 "moonshot-provisioning-common.vala"
								_tmp12_ = web_provisioning_always_confirm_handler (stack);
#line 728 "moonshot-provisioning-common.c"
							} else {
#line 202 "moonshot-provisioning-common.vala"
								_tmp12_ = FALSE;
#line 732 "moonshot-provisioning-common.c"
							}
#line 202 "moonshot-provisioning-common.vala"
							if (_tmp12_) {
#line 736 "moonshot-provisioning-common.c"
								gboolean _tmp13_ = FALSE;
#line 204 "moonshot-provisioning-common.vala"
								if (_vala_strcmp0 (text, "true") == 0) {
#line 204 "moonshot-provisioning-common.vala"
									_tmp13_ = TRUE;
#line 742 "moonshot-provisioning-common.c"
								} else {
#line 204 "moonshot-provisioning-common.vala"
									_tmp13_ = _vala_strcmp0 (text, "false") == 0;
#line 746 "moonshot-provisioning-common.c"
								}
#line 204 "moonshot-provisioning-common.vala"
								if (_tmp13_) {
#line 750 "moonshot-provisioning-common.c"
									gint temp_length1;
									gint _temp_size_;
									Rule* _tmp16_;
									gint _tmp14_;
									Rule* _tmp15_;
									Rule* temp;
									gint _tmp17_;
									char* *_tmp18_;
									char* _tmp19_;
									temp = (_tmp16_ = (_tmp15_ = id_card_get_rules (self->priv->card, &_tmp14_), (_tmp15_ == NULL) ? ((gpointer) _tmp15_) : _vala_array_dup3 (_tmp15_, _tmp14_)), temp_length1 = _tmp14_, _temp_size_ = temp_length1, _tmp16_);
#line 207 "moonshot-provisioning-common.vala"
									_tmp18_ = &id_card_get_rules (self->priv->card, &_tmp17_)[temp_length1 - 1].always_confirm;
#line 207 "moonshot-provisioning-common.vala"
									(*_tmp18_) = (_tmp19_ = g_strdup (text), _g_free0 ((*_tmp18_)), _tmp19_);
#line 765 "moonshot-provisioning-common.c"
									temp = (_vala_Rule_array_free (temp, temp_length1), NULL);
								}
							} else {
								gboolean _tmp20_ = FALSE;
#line 210 "moonshot-provisioning-common.vala"
								if (_vala_strcmp0 ((const char*) g_slist_nth_data (stack, (guint) 0), "ca-cert") == 0) {
#line 210 "moonshot-provisioning-common.vala"
									_tmp20_ = web_provisioning_ca_cert_handler (stack);
#line 774 "moonshot-provisioning-common.c"
								} else {
#line 210 "moonshot-provisioning-common.vala"
									_tmp20_ = FALSE;
#line 778 "moonshot-provisioning-common.c"
								}
#line 210 "moonshot-provisioning-common.vala"
								if (_tmp20_) {
#line 782 "moonshot-provisioning-common.c"
									char* _tmp21_;
									char* _tmp23_;
#line 212 "moonshot-provisioning-common.vala"
									_tmp21_ = g_strdup (text);
#line 212 "moonshot-provisioning-common.vala"
									if (_tmp21_ == NULL) {
#line 789 "moonshot-provisioning-common.c"
										char* _tmp22_;
#line 212 "moonshot-provisioning-common.vala"
										_tmp21_ = (_tmp22_ = g_strdup (""), _g_free0 (_tmp21_), _tmp22_);
#line 793 "moonshot-provisioning-common.c"
									}
#line 212 "moonshot-provisioning-common.vala"
									self->priv->ta_ca_cert = (_tmp23_ = g_strdup (_tmp21_), _g_free0 (self->priv->ta_ca_cert), _tmp23_);
#line 797 "moonshot-provisioning-common.c"
									_g_free0 (_tmp21_);
								} else {
									gboolean _tmp24_ = FALSE;
#line 214 "moonshot-provisioning-common.vala"
									if (_vala_strcmp0 ((const char*) g_slist_nth_data (stack, (guint) 0), "server-cert") == 0) {
#line 214 "moonshot-provisioning-common.vala"
										_tmp24_ = web_provisioning_server_cert_handler (stack);
#line 805 "moonshot-provisioning-common.c"
									} else {
#line 214 "moonshot-provisioning-common.vala"
										_tmp24_ = FALSE;
#line 809 "moonshot-provisioning-common.c"
									}
#line 214 "moonshot-provisioning-common.vala"
									if (_tmp24_) {
#line 813 "moonshot-provisioning-common.c"
										char* _tmp25_;
										char* _tmp27_;
#line 216 "moonshot-provisioning-common.vala"
										_tmp25_ = g_strdup (text);
#line 216 "moonshot-provisioning-common.vala"
										if (_tmp25_ == NULL) {
#line 820 "moonshot-provisioning-common.c"
											char* _tmp26_;
#line 216 "moonshot-provisioning-common.vala"
											_tmp25_ = (_tmp26_ = g_strdup (""), _g_free0 (_tmp25_), _tmp26_);
#line 824 "moonshot-provisioning-common.c"
										}
#line 216 "moonshot-provisioning-common.vala"
										self->priv->ta_server_cert = (_tmp27_ = g_strdup (_tmp25_), _g_free0 (self->priv->ta_server_cert), _tmp27_);
#line 828 "moonshot-provisioning-common.c"
										_g_free0 (_tmp25_);
									} else {
										gboolean _tmp28_ = FALSE;
#line 218 "moonshot-provisioning-common.vala"
										if (_vala_strcmp0 ((const char*) g_slist_nth_data (stack, (guint) 0), "subject") == 0) {
#line 218 "moonshot-provisioning-common.vala"
											_tmp28_ = web_provisioning_subject_handler (stack);
#line 836 "moonshot-provisioning-common.c"
										} else {
#line 218 "moonshot-provisioning-common.vala"
											_tmp28_ = FALSE;
#line 840 "moonshot-provisioning-common.c"
										}
#line 218 "moonshot-provisioning-common.vala"
										if (_tmp28_) {
#line 844 "moonshot-provisioning-common.c"
											char* _tmp29_;
#line 220 "moonshot-provisioning-common.vala"
											self->priv->ta_subject = (_tmp29_ = g_strdup (text), _g_free0 (self->priv->ta_subject), _tmp29_);
#line 848 "moonshot-provisioning-common.c"
										} else {
											gboolean _tmp30_ = FALSE;
#line 222 "moonshot-provisioning-common.vala"
											if (_vala_strcmp0 ((const char*) g_slist_nth_data (stack, (guint) 0), "subject-alt") == 0) {
#line 222 "moonshot-provisioning-common.vala"
												_tmp30_ = web_provisioning_subject_alt_handler (stack);
#line 855 "moonshot-provisioning-common.c"
											} else {
#line 222 "moonshot-provisioning-common.vala"
												_tmp30_ = FALSE;
#line 859 "moonshot-provisioning-common.c"
											}
#line 222 "moonshot-provisioning-common.vala"
											if (_tmp30_) {
#line 863 "moonshot-provisioning-common.c"
												char* _tmp31_;
#line 224 "moonshot-provisioning-common.vala"
												self->priv->ta_subject_alt = (_tmp31_ = g_strdup (text), _g_free0 (self->priv->ta_subject_alt), _tmp31_);
#line 867 "moonshot-provisioning-common.c"
											}
										}
									}
								}
							}
						}
					}
				}
			}
		}
	}
}


#line 250 "moonshot-provisioning-common.vala"
WebProvisioningParser* web_provisioning_parser_construct (GType object_type, const char* path) {
#line 884 "moonshot-provisioning-common.c"
	WebProvisioningParser * self = NULL;
	GMarkupParseContext* _tmp0_;
	char* _tmp1_;
	char* _tmp2_;
	GFile* file;
	GError * _inner_error_ = NULL;
#line 250 "moonshot-provisioning-common.vala"
	g_return_val_if_fail (path != NULL, NULL);
#line 250 "moonshot-provisioning-common.vala"
	self = (WebProvisioningParser*) g_object_new (object_type, NULL);
#line 252 "moonshot-provisioning-common.vala"
	self->priv->ctx = (_tmp0_ = g_markup_parse_context_new (&WEB_PROVISIONING_PARSER_parser, 0, self, NULL), _g_markup_parse_context_free0 (self->priv->ctx), _tmp0_);
#line 254 "moonshot-provisioning-common.vala"
	self->priv->text = (_tmp1_ = g_strdup (""), _g_free0 (self->priv->text), _tmp1_);
#line 255 "moonshot-provisioning-common.vala"
	self->priv->path = (_tmp2_ = g_strdup (path), _g_free0 (self->priv->path), _tmp2_);
#line 257 "moonshot-provisioning-common.vala"
	file = g_file_new_for_path (path);
#line 903 "moonshot-provisioning-common.c"
	{
		GFileInputStream* _tmp3_;
		GFileInputStream* _tmp4_;
		GDataInputStream* _tmp5_;
		GDataInputStream* dis;
		char* line;
#line 261 "moonshot-provisioning-common.vala"
		_tmp3_ = g_file_read (file, NULL, &_inner_error_);
#line 912 "moonshot-provisioning-common.c"
		if (_inner_error_ != NULL) {
			goto __catch0_g_error;
		}
#line 261 "moonshot-provisioning-common.vala"
		dis = (_tmp5_ = g_data_input_stream_new ((GInputStream*) (_tmp4_ = _tmp3_)), _g_object_unref0 (_tmp4_), _tmp5_);
#line 918 "moonshot-provisioning-common.c"
		line = NULL;
#line 263 "moonshot-provisioning-common.vala"
		while (TRUE) {
#line 922 "moonshot-provisioning-common.c"
			char* _tmp6_;
			char* _tmp7_;
			char* _tmp8_;
			char* _tmp9_;
#line 263 "moonshot-provisioning-common.vala"
			_tmp6_ = g_data_input_stream_read_line (dis, NULL, NULL, &_inner_error_);
#line 929 "moonshot-provisioning-common.c"
			if (_inner_error_ != NULL) {
				_g_free0 (line);
				_g_object_unref0 (dis);
				goto __catch0_g_error;
			}
#line 263 "moonshot-provisioning-common.vala"
			if (!((line = (_tmp7_ = _tmp6_, _g_free0 (line), _tmp7_)) != NULL)) {
#line 263 "moonshot-provisioning-common.vala"
				break;
#line 939 "moonshot-provisioning-common.c"
			}
#line 264 "moonshot-provisioning-common.vala"
			self->priv->text = (_tmp8_ = g_strconcat (self->priv->text, line, NULL), _g_free0 (self->priv->text), _tmp8_);
#line 270 "moonshot-provisioning-common.vala"
			self->priv->text = (_tmp9_ = g_strconcat (self->priv->text, "\n", NULL), _g_free0 (self->priv->text), _tmp9_);
#line 945 "moonshot-provisioning-common.c"
		}
		_g_free0 (line);
		_g_object_unref0 (dis);
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError * e;
		e = _inner_error_;
		_inner_error_ = NULL;
		{
#line 275 "moonshot-provisioning-common.vala"
			moonshot_logger_error (web_provisioning_parser_logger, "Could not retreive file size", NULL);
#line 959 "moonshot-provisioning-common.c"
			_g_error_free0 (e);
		}
	}
	__finally0:
	if (_inner_error_ != NULL) {
		_g_object_unref0 (file);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return NULL;
	}
	_g_object_unref0 (file);
	return self;
}


#line 250 "moonshot-provisioning-common.vala"
WebProvisioningParser* web_provisioning_parser_new (const char* path) {
#line 250 "moonshot-provisioning-common.vala"
	return web_provisioning_parser_construct (WEB_PROVISIONING_TYPE_PARSER, path);
#line 979 "moonshot-provisioning-common.c"
}


static glong string_get_length (const char* self) {
	glong result;
	g_return_val_if_fail (self != NULL, 0L);
	result = g_utf8_strlen (self, (gssize) (-1));
#line 1194 "glib-2.0.vapi"
	return result;
#line 989 "moonshot-provisioning-common.c"
}


#line 279 "moonshot-provisioning-common.vala"
gboolean web_provisioning_parser_parse (WebProvisioningParser* self) {
#line 995 "moonshot-provisioning-common.c"
	gboolean result = FALSE;
	GError * _inner_error_ = NULL;
#line 279 "moonshot-provisioning-common.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1000 "moonshot-provisioning-common.c"
	{
#line 282 "moonshot-provisioning-common.vala"
		g_markup_parse_context_parse (self->priv->ctx, self->priv->text, (gssize) string_get_length (self->priv->text), &_inner_error_);
#line 1004 "moonshot-provisioning-common.c"
		if (_inner_error_ != NULL) {
			goto __catch1_g_error;
		}
		result = TRUE;
#line 283 "moonshot-provisioning-common.vala"
		return result;
#line 1011 "moonshot-provisioning-common.c"
	}
	goto __finally1;
	__catch1_g_error:
	{
		GError * e;
		e = _inner_error_;
		_inner_error_ = NULL;
		{
			char* _tmp0_;
#line 287 "moonshot-provisioning-common.vala"
			moonshot_logger_error (web_provisioning_parser_logger, _tmp0_ = g_strdup_printf ("Could not parse %s, invalid content", self->priv->path), NULL);
#line 1023 "moonshot-provisioning-common.c"
			_g_free0 (_tmp0_);
			result = FALSE;
			_g_error_free0 (e);
#line 288 "moonshot-provisioning-common.vala"
			return result;
#line 1029 "moonshot-provisioning-common.c"
		}
	}
	__finally1:
	{
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return FALSE;
	}
}


IdCard** web_provisioning_parser_get_cards (WebProvisioningParser* self, int* result_length1) {
	IdCard** result;
	IdCard** _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	result = (_tmp0_ = self->priv->_cards, *result_length1 = self->priv->_cards_length1, _tmp0_);
#line 246 "moonshot-provisioning-common.vala"
	return result;
#line 1048 "moonshot-provisioning-common.c"
}


static IdCard** _vala_array_dup4 (IdCard** self, int length) {
	IdCard** result;
	int i;
	result = g_new0 (IdCard*, length + 1);
	for (i = 0; i < length; i++) {
		result[i] = _g_object_ref0 (self[i]);
	}
	return result;
}


static IdCard** _vala_array_dup5 (IdCard** self, int length) {
	IdCard** result;
	int i;
	result = g_new0 (IdCard*, length + 1);
	for (i = 0; i < length; i++) {
		result[i] = _g_object_ref0 (self[i]);
	}
	return result;
}


static void web_provisioning_parser_set_cards (WebProvisioningParser* self, IdCard** value, int value_length1) {
	gint _tmp1__length1;
	gint __tmp1__size_;
	IdCard** _tmp2_;
	IdCard** _tmp0_;
	IdCard** _tmp1_;
	IdCard** _tmp4_;
	IdCard** _tmp5_;
	g_return_if_fail (self != NULL);
	_tmp1_ = (_tmp2_ = (_tmp0_ = value, (_tmp0_ == NULL) ? ((gpointer) _tmp0_) : _vala_array_dup4 (_tmp0_, value_length1)), _tmp1__length1 = value_length1, __tmp1__size_ = _tmp1__length1, _tmp2_);
#line 247 "moonshot-provisioning-common.vala"
	if (_tmp1_ == NULL) {
#line 1086 "moonshot-provisioning-common.c"
		IdCard** _tmp3_;
#line 247 "moonshot-provisioning-common.vala"
		_tmp1_ = (_tmp3_ = g_new0 (IdCard*, 0 + 1), _tmp1_ = (_vala_array_free (_tmp1_, _tmp1__length1, (GDestroyNotify) g_object_unref), NULL), _tmp1__length1 = 0, __tmp1__size_ = _tmp1__length1, _tmp3_);
#line 1090 "moonshot-provisioning-common.c"
	}
#line 247 "moonshot-provisioning-common.vala"
	self->priv->_cards = (_tmp5_ = (_tmp4_ = _tmp1_, (_tmp4_ == NULL) ? ((gpointer) _tmp4_) : _vala_array_dup5 (_tmp4_, _tmp1__length1)), self->priv->_cards = (_vala_array_free (self->priv->_cards, self->priv->_cards_length1, (GDestroyNotify) g_object_unref), NULL), self->priv->_cards_length1 = _tmp1__length1, self->priv->__cards_size_ = self->priv->_cards_length1, _tmp5_);
#line 1094 "moonshot-provisioning-common.c"
	_tmp1_ = (_vala_array_free (_tmp1_, _tmp1__length1, (GDestroyNotify) g_object_unref), NULL);
}


static void web_provisioning_parser_class_init (WebProvisioningParserClass * klass) {
	web_provisioning_parser_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (WebProvisioningParserPrivate));
	G_OBJECT_CLASS (klass)->get_property = web_provisioning_parser_get_property;
	G_OBJECT_CLASS (klass)->set_property = web_provisioning_parser_set_property;
	G_OBJECT_CLASS (klass)->finalize = web_provisioning_parser_finalize;
	web_provisioning_parser_logger = moonshot_logger_new ("WebProvisioning");
}


static void web_provisioning_parser_instance_init (WebProvisioningParser * self) {
	IdCard** _tmp0_ = NULL;
	self->priv = WEB_PROVISIONING_PARSER_GET_PRIVATE (self);
	self->priv->_cards = (_tmp0_ = g_new0 (IdCard*, 0 + 1), _tmp0_);
	self->priv->_cards_length1 = 0;
	self->priv->__cards_size_ = self->priv->_cards_length1;
}


static void web_provisioning_parser_finalize (GObject* obj) {
	WebProvisioningParser * self;
	self = WEB_PROVISIONING_PARSER (obj);
	_g_markup_parse_context_free0 (self->priv->ctx);
	_g_free0 (self->priv->text);
	_g_free0 (self->priv->path);
	_g_free0 (self->priv->ta_ca_cert);
	_g_free0 (self->priv->ta_server_cert);
	_g_free0 (self->priv->ta_subject);
	_g_free0 (self->priv->ta_subject_alt);
	_g_object_unref0 (self->priv->card);
	self->priv->_cards = (_vala_array_free (self->priv->_cards, self->priv->_cards_length1, (GDestroyNotify) g_object_unref), NULL);
	G_OBJECT_CLASS (web_provisioning_parser_parent_class)->finalize (obj);
}


GType web_provisioning_parser_get_type (void) {
	static volatile gsize web_provisioning_parser_type_id__volatile = 0;
	if (g_once_init_enter (&web_provisioning_parser_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (WebProvisioningParserClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) web_provisioning_parser_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (WebProvisioningParser), 0, (GInstanceInitFunc) web_provisioning_parser_instance_init, NULL };
		GType web_provisioning_parser_type_id;
		web_provisioning_parser_type_id = g_type_register_static (G_TYPE_OBJECT, "WebProvisioningParser", &g_define_type_info, 0);
		g_once_init_leave (&web_provisioning_parser_type_id__volatile, web_provisioning_parser_type_id);
	}
	return web_provisioning_parser_type_id__volatile;
}


static void web_provisioning_parser_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec) {
	WebProvisioningParser * self;
	self = WEB_PROVISIONING_PARSER (object);
	switch (property_id) {
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}


static void web_provisioning_parser_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec) {
	WebProvisioningParser * self;
	self = WEB_PROVISIONING_PARSER (object);
	switch (property_id) {
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}


static void _vala_array_destroy (gpointer array, gint array_length, GDestroyNotify destroy_func) {
	if ((array != NULL) && (destroy_func != NULL)) {
		int i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}


static void _vala_array_free (gpointer array, gint array_length, GDestroyNotify destroy_func) {
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}


static gint _vala_array_length (gpointer array) {
	int length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}


static int _vala_strcmp0 (const char * str1, const char * str2) {
	if (str1 == NULL) {
		return -(str1 != str2);
	}
	if (str2 == NULL) {
		return str1 != str2;
	}
	return strcmp (str1, str2);
}




